#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - CMU Frequency Check Global Configuration Register"]
    pub gcr: GCR,
    #[doc = "0x04 - CMU Frequency Check Reference Count Configuration Register"]
    pub rccr: RCCR,
    #[doc = "0x08 - CMU Frequency Check High Threshold Configuration Register"]
    pub htcr: HTCR,
    #[doc = "0x0c - CMU Frequency Check Low Threshold Configuration Register"]
    pub ltcr: LTCR,
    #[doc = "0x10 - CMU Frequency Check Status Register"]
    pub sr: SR,
    #[doc = "0x14 - CMU Frequency Check Interrupt/Event Enable Register"]
    pub ier: IER,
}
#[doc = "CMU Frequency Check Global Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [gcr](gcr) module"]
pub type GCR = crate::Reg<u32, _GCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _GCR;
#[doc = "`read()` method returns [gcr::R](gcr::R) reader structure"]
impl crate::Readable for GCR {}
#[doc = "`write(|w| ..)` method takes [gcr::W](gcr::W) writer structure"]
impl crate::Writable for GCR {}
#[doc = "CMU Frequency Check Global Configuration Register"]
pub mod gcr;
#[doc = "CMU Frequency Check Reference Count Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rccr](rccr) module"]
pub type RCCR = crate::Reg<u32, _RCCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RCCR;
#[doc = "`read()` method returns [rccr::R](rccr::R) reader structure"]
impl crate::Readable for RCCR {}
#[doc = "`write(|w| ..)` method takes [rccr::W](rccr::W) writer structure"]
impl crate::Writable for RCCR {}
#[doc = "CMU Frequency Check Reference Count Configuration Register"]
pub mod rccr;
#[doc = "CMU Frequency Check High Threshold Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [htcr](htcr) module"]
pub type HTCR = crate::Reg<u32, _HTCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _HTCR;
#[doc = "`read()` method returns [htcr::R](htcr::R) reader structure"]
impl crate::Readable for HTCR {}
#[doc = "`write(|w| ..)` method takes [htcr::W](htcr::W) writer structure"]
impl crate::Writable for HTCR {}
#[doc = "CMU Frequency Check High Threshold Configuration Register"]
pub mod htcr;
#[doc = "CMU Frequency Check Low Threshold Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ltcr](ltcr) module"]
pub type LTCR = crate::Reg<u32, _LTCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _LTCR;
#[doc = "`read()` method returns [ltcr::R](ltcr::R) reader structure"]
impl crate::Readable for LTCR {}
#[doc = "`write(|w| ..)` method takes [ltcr::W](ltcr::W) writer structure"]
impl crate::Writable for LTCR {}
#[doc = "CMU Frequency Check Low Threshold Configuration Register"]
pub mod ltcr;
#[doc = "CMU Frequency Check Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [sr](sr) module"]
pub type SR = crate::Reg<u32, _SR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SR;
#[doc = "`read()` method returns [sr::R](sr::R) reader structure"]
impl crate::Readable for SR {}
#[doc = "`write(|w| ..)` method takes [sr::W](sr::W) writer structure"]
impl crate::Writable for SR {}
#[doc = "CMU Frequency Check Status Register"]
pub mod sr;
#[doc = "CMU Frequency Check Interrupt/Event Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ier](ier) module"]
pub type IER = crate::Reg<u32, _IER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IER;
#[doc = "`read()` method returns [ier::R](ier::R) reader structure"]
impl crate::Readable for IER {}
#[doc = "`write(|w| ..)` method takes [ier::W](ier::W) writer structure"]
impl crate::Writable for IER {}
#[doc = "CMU Frequency Check Interrupt/Event Enable Register"]
pub mod ier;
