#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Control Register"]
    pub cr: CR,
    #[doc = "0x04 - Error Status Register"]
    pub es: ES,
    _reserved2: [u8; 4usize],
    #[doc = "0x0c - Enable Request Register"]
    pub erq: ERQ,
    _reserved3: [u8; 4usize],
    #[doc = "0x14 - Enable Error Interrupt Register"]
    pub eei: EEI,
    #[doc = "0x18 - Clear Enable Error Interrupt Register"]
    pub ceei: CEEI,
    #[doc = "0x19 - Set Enable Error Interrupt Register"]
    pub seei: SEEI,
    #[doc = "0x1a - Clear Enable Request Register"]
    pub cerq: CERQ,
    #[doc = "0x1b - Set Enable Request Register"]
    pub serq: SERQ,
    #[doc = "0x1c - Clear DONE Status Bit Register"]
    pub cdne: CDNE,
    #[doc = "0x1d - Set START Bit Register"]
    pub ssrt: SSRT,
    #[doc = "0x1e - Clear Error Register"]
    pub cerr: CERR,
    #[doc = "0x1f - Clear Interrupt Request Register"]
    pub cint: CINT,
    _reserved12: [u8; 4usize],
    #[doc = "0x24 - Interrupt Request Register"]
    pub int: INT,
    _reserved13: [u8; 4usize],
    #[doc = "0x2c - Error Register"]
    pub err: ERR,
    _reserved14: [u8; 4usize],
    #[doc = "0x34 - Hardware Request Status Register"]
    pub hrs: HRS,
    _reserved15: [u8; 12usize],
    #[doc = "0x44 - Enable Asynchronous Request in Stop Register"]
    pub ears: EARS,
    _reserved16: [u8; 184usize],
    #[doc = "0x100 - Channel n Priority Register"]
    pub dchpri3: DCHPRI3,
    #[doc = "0x101 - Channel n Priority Register"]
    pub dchpri2: DCHPRI2,
    #[doc = "0x102 - Channel n Priority Register"]
    pub dchpri1: DCHPRI1,
    #[doc = "0x103 - Channel n Priority Register"]
    pub dchpri0: DCHPRI0,
    _reserved20: [u8; 3836usize],
    #[doc = "0x1000 - TCD Source Address"]
    pub tcd0_saddr: TCD0_SADDR,
    #[doc = "0x1004 - TCD Signed Source Address Offset"]
    pub tcd0_soff: TCD0_SOFF,
    #[doc = "0x1006 - TCD Transfer Attributes"]
    pub tcd0_attr: TCD0_ATTR,
    _reserved_23_tcd0_nbytes: [u8; 4usize],
    #[doc = "0x100c - TCD Last Source Address Adjustment"]
    pub tcd0_slast: TCD0_SLAST,
    #[doc = "0x1010 - TCD Destination Address"]
    pub tcd0_daddr: TCD0_DADDR,
    #[doc = "0x1014 - TCD Signed Destination Address Offset"]
    pub tcd0_doff: TCD0_DOFF,
    _reserved_27_tcd0_citer: [u8; 2usize],
    #[doc = "0x1018 - TCD Last Destination Address Adjustment/Scatter Gather Address"]
    pub tcd0_dlastsga: TCD0_DLASTSGA,
    #[doc = "0x101c - TCD Control and Status"]
    pub tcd0_csr: TCD0_CSR,
    _reserved_30_tcd0_biter: [u8; 2usize],
    #[doc = "0x1020 - TCD Source Address"]
    pub tcd1_saddr: TCD1_SADDR,
    #[doc = "0x1024 - TCD Signed Source Address Offset"]
    pub tcd1_soff: TCD1_SOFF,
    #[doc = "0x1026 - TCD Transfer Attributes"]
    pub tcd1_attr: TCD1_ATTR,
    _reserved_34_tcd1_nbytes: [u8; 4usize],
    #[doc = "0x102c - TCD Last Source Address Adjustment"]
    pub tcd1_slast: TCD1_SLAST,
    #[doc = "0x1030 - TCD Destination Address"]
    pub tcd1_daddr: TCD1_DADDR,
    #[doc = "0x1034 - TCD Signed Destination Address Offset"]
    pub tcd1_doff: TCD1_DOFF,
    _reserved_38_tcd1_citer: [u8; 2usize],
    #[doc = "0x1038 - TCD Last Destination Address Adjustment/Scatter Gather Address"]
    pub tcd1_dlastsga: TCD1_DLASTSGA,
    #[doc = "0x103c - TCD Control and Status"]
    pub tcd1_csr: TCD1_CSR,
    _reserved_41_tcd1_biter: [u8; 2usize],
    #[doc = "0x1040 - TCD Source Address"]
    pub tcd2_saddr: TCD2_SADDR,
    #[doc = "0x1044 - TCD Signed Source Address Offset"]
    pub tcd2_soff: TCD2_SOFF,
    #[doc = "0x1046 - TCD Transfer Attributes"]
    pub tcd2_attr: TCD2_ATTR,
    _reserved_45_tcd2_nbytes: [u8; 4usize],
    #[doc = "0x104c - TCD Last Source Address Adjustment"]
    pub tcd2_slast: TCD2_SLAST,
    #[doc = "0x1050 - TCD Destination Address"]
    pub tcd2_daddr: TCD2_DADDR,
    #[doc = "0x1054 - TCD Signed Destination Address Offset"]
    pub tcd2_doff: TCD2_DOFF,
    _reserved_49_tcd2_citer: [u8; 2usize],
    #[doc = "0x1058 - TCD Last Destination Address Adjustment/Scatter Gather Address"]
    pub tcd2_dlastsga: TCD2_DLASTSGA,
    #[doc = "0x105c - TCD Control and Status"]
    pub tcd2_csr: TCD2_CSR,
    _reserved_52_tcd2_biter: [u8; 2usize],
    #[doc = "0x1060 - TCD Source Address"]
    pub tcd3_saddr: TCD3_SADDR,
    #[doc = "0x1064 - TCD Signed Source Address Offset"]
    pub tcd3_soff: TCD3_SOFF,
    #[doc = "0x1066 - TCD Transfer Attributes"]
    pub tcd3_attr: TCD3_ATTR,
    _reserved_56_tcd3_nbytes: [u8; 4usize],
    #[doc = "0x106c - TCD Last Source Address Adjustment"]
    pub tcd3_slast: TCD3_SLAST,
    #[doc = "0x1070 - TCD Destination Address"]
    pub tcd3_daddr: TCD3_DADDR,
    #[doc = "0x1074 - TCD Signed Destination Address Offset"]
    pub tcd3_doff: TCD3_DOFF,
    _reserved_60_tcd3_citer: [u8; 2usize],
    #[doc = "0x1078 - TCD Last Destination Address Adjustment/Scatter Gather Address"]
    pub tcd3_dlastsga: TCD3_DLASTSGA,
    #[doc = "0x107c - TCD Control and Status"]
    pub tcd3_csr: TCD3_CSR,
    _reserved_63_tcd3_biter: [u8; 2usize],
}
impl RegisterBlock {
    #[doc = "0x1008 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mloffyes(&self) -> &TCD0_NBYTES_MLOFFYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4104usize) as *const TCD0_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1008 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mloffyes_mut(&self) -> &mut TCD0_NBYTES_MLOFFYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4104usize) as *mut TCD0_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1008 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mloffno(&self) -> &TCD0_NBYTES_MLOFFNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4104usize) as *const TCD0_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1008 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mloffno_mut(&self) -> &mut TCD0_NBYTES_MLOFFNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4104usize) as *mut TCD0_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1008 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mlno(&self) -> &TCD0_NBYTES_MLNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4104usize) as *const TCD0_NBYTES_MLNO) }
    }
    #[doc = "0x1008 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd0_nbytes_mlno_mut(&self) -> &mut TCD0_NBYTES_MLNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4104usize) as *mut TCD0_NBYTES_MLNO) }
    }
    #[doc = "0x1016 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd0_citer_elinkyes(&self) -> &TCD0_CITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4118usize) as *const TCD0_CITER_ELINKYES) }
    }
    #[doc = "0x1016 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd0_citer_elinkyes_mut(&self) -> &mut TCD0_CITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4118usize) as *mut TCD0_CITER_ELINKYES) }
    }
    #[doc = "0x1016 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd0_citer_elinkno(&self) -> &TCD0_CITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4118usize) as *const TCD0_CITER_ELINKNO) }
    }
    #[doc = "0x1016 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd0_citer_elinkno_mut(&self) -> &mut TCD0_CITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4118usize) as *mut TCD0_CITER_ELINKNO) }
    }
    #[doc = "0x101e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd0_biter_elinkyes(&self) -> &TCD0_BITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4126usize) as *const TCD0_BITER_ELINKYES) }
    }
    #[doc = "0x101e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd0_biter_elinkyes_mut(&self) -> &mut TCD0_BITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4126usize) as *mut TCD0_BITER_ELINKYES) }
    }
    #[doc = "0x101e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd0_biter_elinkno(&self) -> &TCD0_BITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4126usize) as *const TCD0_BITER_ELINKNO) }
    }
    #[doc = "0x101e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd0_biter_elinkno_mut(&self) -> &mut TCD0_BITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4126usize) as *mut TCD0_BITER_ELINKNO) }
    }
    #[doc = "0x1028 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mloffyes(&self) -> &TCD1_NBYTES_MLOFFYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4136usize) as *const TCD1_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1028 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mloffyes_mut(&self) -> &mut TCD1_NBYTES_MLOFFYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4136usize) as *mut TCD1_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1028 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mloffno(&self) -> &TCD1_NBYTES_MLOFFNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4136usize) as *const TCD1_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1028 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mloffno_mut(&self) -> &mut TCD1_NBYTES_MLOFFNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4136usize) as *mut TCD1_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1028 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mlno(&self) -> &TCD1_NBYTES_MLNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4136usize) as *const TCD1_NBYTES_MLNO) }
    }
    #[doc = "0x1028 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd1_nbytes_mlno_mut(&self) -> &mut TCD1_NBYTES_MLNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4136usize) as *mut TCD1_NBYTES_MLNO) }
    }
    #[doc = "0x1036 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd1_citer_elinkyes(&self) -> &TCD1_CITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4150usize) as *const TCD1_CITER_ELINKYES) }
    }
    #[doc = "0x1036 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd1_citer_elinkyes_mut(&self) -> &mut TCD1_CITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4150usize) as *mut TCD1_CITER_ELINKYES) }
    }
    #[doc = "0x1036 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd1_citer_elinkno(&self) -> &TCD1_CITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4150usize) as *const TCD1_CITER_ELINKNO) }
    }
    #[doc = "0x1036 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd1_citer_elinkno_mut(&self) -> &mut TCD1_CITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4150usize) as *mut TCD1_CITER_ELINKNO) }
    }
    #[doc = "0x103e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd1_biter_elinkyes(&self) -> &TCD1_BITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4158usize) as *const TCD1_BITER_ELINKYES) }
    }
    #[doc = "0x103e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd1_biter_elinkyes_mut(&self) -> &mut TCD1_BITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4158usize) as *mut TCD1_BITER_ELINKYES) }
    }
    #[doc = "0x103e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd1_biter_elinkno(&self) -> &TCD1_BITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4158usize) as *const TCD1_BITER_ELINKNO) }
    }
    #[doc = "0x103e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd1_biter_elinkno_mut(&self) -> &mut TCD1_BITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4158usize) as *mut TCD1_BITER_ELINKNO) }
    }
    #[doc = "0x1048 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mloffyes(&self) -> &TCD2_NBYTES_MLOFFYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4168usize) as *const TCD2_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1048 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mloffyes_mut(&self) -> &mut TCD2_NBYTES_MLOFFYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4168usize) as *mut TCD2_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1048 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mloffno(&self) -> &TCD2_NBYTES_MLOFFNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4168usize) as *const TCD2_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1048 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mloffno_mut(&self) -> &mut TCD2_NBYTES_MLOFFNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4168usize) as *mut TCD2_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1048 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mlno(&self) -> &TCD2_NBYTES_MLNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4168usize) as *const TCD2_NBYTES_MLNO) }
    }
    #[doc = "0x1048 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd2_nbytes_mlno_mut(&self) -> &mut TCD2_NBYTES_MLNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4168usize) as *mut TCD2_NBYTES_MLNO) }
    }
    #[doc = "0x1056 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd2_citer_elinkyes(&self) -> &TCD2_CITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4182usize) as *const TCD2_CITER_ELINKYES) }
    }
    #[doc = "0x1056 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd2_citer_elinkyes_mut(&self) -> &mut TCD2_CITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4182usize) as *mut TCD2_CITER_ELINKYES) }
    }
    #[doc = "0x1056 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd2_citer_elinkno(&self) -> &TCD2_CITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4182usize) as *const TCD2_CITER_ELINKNO) }
    }
    #[doc = "0x1056 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd2_citer_elinkno_mut(&self) -> &mut TCD2_CITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4182usize) as *mut TCD2_CITER_ELINKNO) }
    }
    #[doc = "0x105e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd2_biter_elinkyes(&self) -> &TCD2_BITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4190usize) as *const TCD2_BITER_ELINKYES) }
    }
    #[doc = "0x105e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd2_biter_elinkyes_mut(&self) -> &mut TCD2_BITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4190usize) as *mut TCD2_BITER_ELINKYES) }
    }
    #[doc = "0x105e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd2_biter_elinkno(&self) -> &TCD2_BITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4190usize) as *const TCD2_BITER_ELINKNO) }
    }
    #[doc = "0x105e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd2_biter_elinkno_mut(&self) -> &mut TCD2_BITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4190usize) as *mut TCD2_BITER_ELINKNO) }
    }
    #[doc = "0x1068 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mloffyes(&self) -> &TCD3_NBYTES_MLOFFYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4200usize) as *const TCD3_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1068 - TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mloffyes_mut(&self) -> &mut TCD3_NBYTES_MLOFFYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4200usize) as *mut TCD3_NBYTES_MLOFFYES) }
    }
    #[doc = "0x1068 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mloffno(&self) -> &TCD3_NBYTES_MLOFFNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4200usize) as *const TCD3_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1068 - TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mloffno_mut(&self) -> &mut TCD3_NBYTES_MLOFFNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4200usize) as *mut TCD3_NBYTES_MLOFFNO) }
    }
    #[doc = "0x1068 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mlno(&self) -> &TCD3_NBYTES_MLNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4200usize) as *const TCD3_NBYTES_MLNO) }
    }
    #[doc = "0x1068 - TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
    #[inline(always)]
    pub fn tcd3_nbytes_mlno_mut(&self) -> &mut TCD3_NBYTES_MLNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4200usize) as *mut TCD3_NBYTES_MLNO) }
    }
    #[doc = "0x1076 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd3_citer_elinkyes(&self) -> &TCD3_CITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4214usize) as *const TCD3_CITER_ELINKYES) }
    }
    #[doc = "0x1076 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd3_citer_elinkyes_mut(&self) -> &mut TCD3_CITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4214usize) as *mut TCD3_CITER_ELINKYES) }
    }
    #[doc = "0x1076 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd3_citer_elinkno(&self) -> &TCD3_CITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4214usize) as *const TCD3_CITER_ELINKNO) }
    }
    #[doc = "0x1076 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd3_citer_elinkno_mut(&self) -> &mut TCD3_CITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4214usize) as *mut TCD3_CITER_ELINKNO) }
    }
    #[doc = "0x107e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd3_biter_elinkyes(&self) -> &TCD3_BITER_ELINKYES {
        unsafe { &*(((self as *const Self) as *const u8).add(4222usize) as *const TCD3_BITER_ELINKYES) }
    }
    #[doc = "0x107e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
    #[inline(always)]
    pub fn tcd3_biter_elinkyes_mut(&self) -> &mut TCD3_BITER_ELINKYES {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4222usize) as *mut TCD3_BITER_ELINKYES) }
    }
    #[doc = "0x107e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd3_biter_elinkno(&self) -> &TCD3_BITER_ELINKNO {
        unsafe { &*(((self as *const Self) as *const u8).add(4222usize) as *const TCD3_BITER_ELINKNO) }
    }
    #[doc = "0x107e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
    #[inline(always)]
    pub fn tcd3_biter_elinkno_mut(&self) -> &mut TCD3_BITER_ELINKNO {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(4222usize) as *mut TCD3_BITER_ELINKNO) }
    }
}
#[doc = "Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cr](cr) module"]
pub type CR = crate::Reg<u32, _CR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CR;
#[doc = "`read()` method returns [cr::R](cr::R) reader structure"]
impl crate::Readable for CR {}
#[doc = "`write(|w| ..)` method takes [cr::W](cr::W) writer structure"]
impl crate::Writable for CR {}
#[doc = "Control Register"]
pub mod cr;
#[doc = "Error Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [es](es) module"]
pub type ES = crate::Reg<u32, _ES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ES;
#[doc = "`read()` method returns [es::R](es::R) reader structure"]
impl crate::Readable for ES {}
#[doc = "Error Status Register"]
pub mod es;
#[doc = "Enable Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [erq](erq) module"]
pub type ERQ = crate::Reg<u32, _ERQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ERQ;
#[doc = "`read()` method returns [erq::R](erq::R) reader structure"]
impl crate::Readable for ERQ {}
#[doc = "`write(|w| ..)` method takes [erq::W](erq::W) writer structure"]
impl crate::Writable for ERQ {}
#[doc = "Enable Request Register"]
pub mod erq;
#[doc = "Enable Error Interrupt Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [eei](eei) module"]
pub type EEI = crate::Reg<u32, _EEI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EEI;
#[doc = "`read()` method returns [eei::R](eei::R) reader structure"]
impl crate::Readable for EEI {}
#[doc = "`write(|w| ..)` method takes [eei::W](eei::W) writer structure"]
impl crate::Writable for EEI {}
#[doc = "Enable Error Interrupt Register"]
pub mod eei;
#[doc = "Clear Enable Error Interrupt Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ceei](ceei) module"]
pub type CEEI = crate::Reg<u8, _CEEI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CEEI;
#[doc = "`write(|w| ..)` method takes [ceei::W](ceei::W) writer structure"]
impl crate::Writable for CEEI {}
#[doc = "Clear Enable Error Interrupt Register"]
pub mod ceei;
#[doc = "Set Enable Error Interrupt Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [seei](seei) module"]
pub type SEEI = crate::Reg<u8, _SEEI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SEEI;
#[doc = "`write(|w| ..)` method takes [seei::W](seei::W) writer structure"]
impl crate::Writable for SEEI {}
#[doc = "Set Enable Error Interrupt Register"]
pub mod seei;
#[doc = "Clear Enable Request Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cerq](cerq) module"]
pub type CERQ = crate::Reg<u8, _CERQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CERQ;
#[doc = "`write(|w| ..)` method takes [cerq::W](cerq::W) writer structure"]
impl crate::Writable for CERQ {}
#[doc = "Clear Enable Request Register"]
pub mod cerq;
#[doc = "Set Enable Request Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [serq](serq) module"]
pub type SERQ = crate::Reg<u8, _SERQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SERQ;
#[doc = "`write(|w| ..)` method takes [serq::W](serq::W) writer structure"]
impl crate::Writable for SERQ {}
#[doc = "Set Enable Request Register"]
pub mod serq;
#[doc = "Clear DONE Status Bit Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cdne](cdne) module"]
pub type CDNE = crate::Reg<u8, _CDNE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CDNE;
#[doc = "`write(|w| ..)` method takes [cdne::W](cdne::W) writer structure"]
impl crate::Writable for CDNE {}
#[doc = "Clear DONE Status Bit Register"]
pub mod cdne;
#[doc = "Set START Bit Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ssrt](ssrt) module"]
pub type SSRT = crate::Reg<u8, _SSRT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SSRT;
#[doc = "`write(|w| ..)` method takes [ssrt::W](ssrt::W) writer structure"]
impl crate::Writable for SSRT {}
#[doc = "Set START Bit Register"]
pub mod ssrt;
#[doc = "Clear Error Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cerr](cerr) module"]
pub type CERR = crate::Reg<u8, _CERR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CERR;
#[doc = "`write(|w| ..)` method takes [cerr::W](cerr::W) writer structure"]
impl crate::Writable for CERR {}
#[doc = "Clear Error Register"]
pub mod cerr;
#[doc = "Clear Interrupt Request Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cint](cint) module"]
pub type CINT = crate::Reg<u8, _CINT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CINT;
#[doc = "`write(|w| ..)` method takes [cint::W](cint::W) writer structure"]
impl crate::Writable for CINT {}
#[doc = "Clear Interrupt Request Register"]
pub mod cint;
#[doc = "Interrupt Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [int](int) module"]
pub type INT = crate::Reg<u32, _INT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INT;
#[doc = "`read()` method returns [int::R](int::R) reader structure"]
impl crate::Readable for INT {}
#[doc = "`write(|w| ..)` method takes [int::W](int::W) writer structure"]
impl crate::Writable for INT {}
#[doc = "Interrupt Request Register"]
pub mod int;
#[doc = "Error Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [err](err) module"]
pub type ERR = crate::Reg<u32, _ERR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ERR;
#[doc = "`read()` method returns [err::R](err::R) reader structure"]
impl crate::Readable for ERR {}
#[doc = "`write(|w| ..)` method takes [err::W](err::W) writer structure"]
impl crate::Writable for ERR {}
#[doc = "Error Register"]
pub mod err;
#[doc = "Hardware Request Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [hrs](hrs) module"]
pub type HRS = crate::Reg<u32, _HRS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _HRS;
#[doc = "`read()` method returns [hrs::R](hrs::R) reader structure"]
impl crate::Readable for HRS {}
#[doc = "Hardware Request Status Register"]
pub mod hrs;
#[doc = "Enable Asynchronous Request in Stop Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ears](ears) module"]
pub type EARS = crate::Reg<u32, _EARS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EARS;
#[doc = "`read()` method returns [ears::R](ears::R) reader structure"]
impl crate::Readable for EARS {}
#[doc = "`write(|w| ..)` method takes [ears::W](ears::W) writer structure"]
impl crate::Writable for EARS {}
#[doc = "Enable Asynchronous Request in Stop Register"]
pub mod ears;
#[doc = "Channel n Priority Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dchpri3](dchpri3) module"]
pub type DCHPRI3 = crate::Reg<u8, _DCHPRI3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DCHPRI3;
#[doc = "`read()` method returns [dchpri3::R](dchpri3::R) reader structure"]
impl crate::Readable for DCHPRI3 {}
#[doc = "`write(|w| ..)` method takes [dchpri3::W](dchpri3::W) writer structure"]
impl crate::Writable for DCHPRI3 {}
#[doc = "Channel n Priority Register"]
pub mod dchpri3;
#[doc = "Channel n Priority Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dchpri2](dchpri2) module"]
pub type DCHPRI2 = crate::Reg<u8, _DCHPRI2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DCHPRI2;
#[doc = "`read()` method returns [dchpri2::R](dchpri2::R) reader structure"]
impl crate::Readable for DCHPRI2 {}
#[doc = "`write(|w| ..)` method takes [dchpri2::W](dchpri2::W) writer structure"]
impl crate::Writable for DCHPRI2 {}
#[doc = "Channel n Priority Register"]
pub mod dchpri2;
#[doc = "Channel n Priority Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dchpri1](dchpri1) module"]
pub type DCHPRI1 = crate::Reg<u8, _DCHPRI1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DCHPRI1;
#[doc = "`read()` method returns [dchpri1::R](dchpri1::R) reader structure"]
impl crate::Readable for DCHPRI1 {}
#[doc = "`write(|w| ..)` method takes [dchpri1::W](dchpri1::W) writer structure"]
impl crate::Writable for DCHPRI1 {}
#[doc = "Channel n Priority Register"]
pub mod dchpri1;
#[doc = "Channel n Priority Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dchpri0](dchpri0) module"]
pub type DCHPRI0 = crate::Reg<u8, _DCHPRI0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DCHPRI0;
#[doc = "`read()` method returns [dchpri0::R](dchpri0::R) reader structure"]
impl crate::Readable for DCHPRI0 {}
#[doc = "`write(|w| ..)` method takes [dchpri0::W](dchpri0::W) writer structure"]
impl crate::Writable for DCHPRI0 {}
#[doc = "Channel n Priority Register"]
pub mod dchpri0;
#[doc = "TCD Source Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_saddr](tcd0_saddr) module"]
pub type TCD0_SADDR = crate::Reg<u32, _TCD0_SADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_SADDR;
#[doc = "`read()` method returns [tcd0_saddr::R](tcd0_saddr::R) reader structure"]
impl crate::Readable for TCD0_SADDR {}
#[doc = "`write(|w| ..)` method takes [tcd0_saddr::W](tcd0_saddr::W) writer structure"]
impl crate::Writable for TCD0_SADDR {}
#[doc = "TCD Source Address"]
pub mod tcd0_saddr;
#[doc = "TCD Signed Source Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_soff](tcd0_soff) module"]
pub type TCD0_SOFF = crate::Reg<u16, _TCD0_SOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_SOFF;
#[doc = "`read()` method returns [tcd0_soff::R](tcd0_soff::R) reader structure"]
impl crate::Readable for TCD0_SOFF {}
#[doc = "`write(|w| ..)` method takes [tcd0_soff::W](tcd0_soff::W) writer structure"]
impl crate::Writable for TCD0_SOFF {}
#[doc = "TCD Signed Source Address Offset"]
pub mod tcd0_soff;
#[doc = "TCD Transfer Attributes\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_attr](tcd0_attr) module"]
pub type TCD0_ATTR = crate::Reg<u16, _TCD0_ATTR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_ATTR;
#[doc = "`read()` method returns [tcd0_attr::R](tcd0_attr::R) reader structure"]
impl crate::Readable for TCD0_ATTR {}
#[doc = "`write(|w| ..)` method takes [tcd0_attr::W](tcd0_attr::W) writer structure"]
impl crate::Writable for TCD0_ATTR {}
#[doc = "TCD Transfer Attributes"]
pub mod tcd0_attr;
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_nbytes_mlno](tcd0_nbytes_mlno) module"]
pub type TCD0_NBYTES_MLNO = crate::Reg<u32, _TCD0_NBYTES_MLNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_NBYTES_MLNO;
#[doc = "`read()` method returns [tcd0_nbytes_mlno::R](tcd0_nbytes_mlno::R) reader structure"]
impl crate::Readable for TCD0_NBYTES_MLNO {}
#[doc = "`write(|w| ..)` method takes [tcd0_nbytes_mlno::W](tcd0_nbytes_mlno::W) writer structure"]
impl crate::Writable for TCD0_NBYTES_MLNO {}
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
pub mod tcd0_nbytes_mlno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_nbytes_mloffno](tcd0_nbytes_mloffno) module"]
pub type TCD0_NBYTES_MLOFFNO = crate::Reg<u32, _TCD0_NBYTES_MLOFFNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_NBYTES_MLOFFNO;
#[doc = "`read()` method returns [tcd0_nbytes_mloffno::R](tcd0_nbytes_mloffno::R) reader structure"]
impl crate::Readable for TCD0_NBYTES_MLOFFNO {}
#[doc = "`write(|w| ..)` method takes [tcd0_nbytes_mloffno::W](tcd0_nbytes_mloffno::W) writer structure"]
impl crate::Writable for TCD0_NBYTES_MLOFFNO {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
pub mod tcd0_nbytes_mloffno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_nbytes_mloffyes](tcd0_nbytes_mloffyes) module"]
pub type TCD0_NBYTES_MLOFFYES = crate::Reg<u32, _TCD0_NBYTES_MLOFFYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_NBYTES_MLOFFYES;
#[doc = "`read()` method returns [tcd0_nbytes_mloffyes::R](tcd0_nbytes_mloffyes::R) reader structure"]
impl crate::Readable for TCD0_NBYTES_MLOFFYES {}
#[doc = "`write(|w| ..)` method takes [tcd0_nbytes_mloffyes::W](tcd0_nbytes_mloffyes::W) writer structure"]
impl crate::Writable for TCD0_NBYTES_MLOFFYES {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
pub mod tcd0_nbytes_mloffyes;
#[doc = "TCD Last Source Address Adjustment\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_slast](tcd0_slast) module"]
pub type TCD0_SLAST = crate::Reg<u32, _TCD0_SLAST>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_SLAST;
#[doc = "`read()` method returns [tcd0_slast::R](tcd0_slast::R) reader structure"]
impl crate::Readable for TCD0_SLAST {}
#[doc = "`write(|w| ..)` method takes [tcd0_slast::W](tcd0_slast::W) writer structure"]
impl crate::Writable for TCD0_SLAST {}
#[doc = "TCD Last Source Address Adjustment"]
pub mod tcd0_slast;
#[doc = "TCD Destination Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_daddr](tcd0_daddr) module"]
pub type TCD0_DADDR = crate::Reg<u32, _TCD0_DADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_DADDR;
#[doc = "`read()` method returns [tcd0_daddr::R](tcd0_daddr::R) reader structure"]
impl crate::Readable for TCD0_DADDR {}
#[doc = "`write(|w| ..)` method takes [tcd0_daddr::W](tcd0_daddr::W) writer structure"]
impl crate::Writable for TCD0_DADDR {}
#[doc = "TCD Destination Address"]
pub mod tcd0_daddr;
#[doc = "TCD Signed Destination Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_doff](tcd0_doff) module"]
pub type TCD0_DOFF = crate::Reg<u16, _TCD0_DOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_DOFF;
#[doc = "`read()` method returns [tcd0_doff::R](tcd0_doff::R) reader structure"]
impl crate::Readable for TCD0_DOFF {}
#[doc = "`write(|w| ..)` method takes [tcd0_doff::W](tcd0_doff::W) writer structure"]
impl crate::Writable for TCD0_DOFF {}
#[doc = "TCD Signed Destination Address Offset"]
pub mod tcd0_doff;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_citer_elinkno](tcd0_citer_elinkno) module"]
pub type TCD0_CITER_ELINKNO = crate::Reg<u16, _TCD0_CITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_CITER_ELINKNO;
#[doc = "`read()` method returns [tcd0_citer_elinkno::R](tcd0_citer_elinkno::R) reader structure"]
impl crate::Readable for TCD0_CITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd0_citer_elinkno::W](tcd0_citer_elinkno::W) writer structure"]
impl crate::Writable for TCD0_CITER_ELINKNO {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd0_citer_elinkno;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_citer_elinkyes](tcd0_citer_elinkyes) module"]
pub type TCD0_CITER_ELINKYES = crate::Reg<u16, _TCD0_CITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_CITER_ELINKYES;
#[doc = "`read()` method returns [tcd0_citer_elinkyes::R](tcd0_citer_elinkyes::R) reader structure"]
impl crate::Readable for TCD0_CITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd0_citer_elinkyes::W](tcd0_citer_elinkyes::W) writer structure"]
impl crate::Writable for TCD0_CITER_ELINKYES {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd0_citer_elinkyes;
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_dlastsga](tcd0_dlastsga) module"]
pub type TCD0_DLASTSGA = crate::Reg<u32, _TCD0_DLASTSGA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_DLASTSGA;
#[doc = "`read()` method returns [tcd0_dlastsga::R](tcd0_dlastsga::R) reader structure"]
impl crate::Readable for TCD0_DLASTSGA {}
#[doc = "`write(|w| ..)` method takes [tcd0_dlastsga::W](tcd0_dlastsga::W) writer structure"]
impl crate::Writable for TCD0_DLASTSGA {}
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address"]
pub mod tcd0_dlastsga;
#[doc = "TCD Control and Status\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_csr](tcd0_csr) module"]
pub type TCD0_CSR = crate::Reg<u16, _TCD0_CSR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_CSR;
#[doc = "`read()` method returns [tcd0_csr::R](tcd0_csr::R) reader structure"]
impl crate::Readable for TCD0_CSR {}
#[doc = "`write(|w| ..)` method takes [tcd0_csr::W](tcd0_csr::W) writer structure"]
impl crate::Writable for TCD0_CSR {}
#[doc = "TCD Control and Status"]
pub mod tcd0_csr;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_biter_elinkno](tcd0_biter_elinkno) module"]
pub type TCD0_BITER_ELINKNO = crate::Reg<u16, _TCD0_BITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_BITER_ELINKNO;
#[doc = "`read()` method returns [tcd0_biter_elinkno::R](tcd0_biter_elinkno::R) reader structure"]
impl crate::Readable for TCD0_BITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd0_biter_elinkno::W](tcd0_biter_elinkno::W) writer structure"]
impl crate::Writable for TCD0_BITER_ELINKNO {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd0_biter_elinkno;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd0_biter_elinkyes](tcd0_biter_elinkyes) module"]
pub type TCD0_BITER_ELINKYES = crate::Reg<u16, _TCD0_BITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD0_BITER_ELINKYES;
#[doc = "`read()` method returns [tcd0_biter_elinkyes::R](tcd0_biter_elinkyes::R) reader structure"]
impl crate::Readable for TCD0_BITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd0_biter_elinkyes::W](tcd0_biter_elinkyes::W) writer structure"]
impl crate::Writable for TCD0_BITER_ELINKYES {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd0_biter_elinkyes;
#[doc = "TCD Source Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_saddr](tcd1_saddr) module"]
pub type TCD1_SADDR = crate::Reg<u32, _TCD1_SADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_SADDR;
#[doc = "`read()` method returns [tcd1_saddr::R](tcd1_saddr::R) reader structure"]
impl crate::Readable for TCD1_SADDR {}
#[doc = "`write(|w| ..)` method takes [tcd1_saddr::W](tcd1_saddr::W) writer structure"]
impl crate::Writable for TCD1_SADDR {}
#[doc = "TCD Source Address"]
pub mod tcd1_saddr;
#[doc = "TCD Signed Source Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_soff](tcd1_soff) module"]
pub type TCD1_SOFF = crate::Reg<u16, _TCD1_SOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_SOFF;
#[doc = "`read()` method returns [tcd1_soff::R](tcd1_soff::R) reader structure"]
impl crate::Readable for TCD1_SOFF {}
#[doc = "`write(|w| ..)` method takes [tcd1_soff::W](tcd1_soff::W) writer structure"]
impl crate::Writable for TCD1_SOFF {}
#[doc = "TCD Signed Source Address Offset"]
pub mod tcd1_soff;
#[doc = "TCD Transfer Attributes\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_attr](tcd1_attr) module"]
pub type TCD1_ATTR = crate::Reg<u16, _TCD1_ATTR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_ATTR;
#[doc = "`read()` method returns [tcd1_attr::R](tcd1_attr::R) reader structure"]
impl crate::Readable for TCD1_ATTR {}
#[doc = "`write(|w| ..)` method takes [tcd1_attr::W](tcd1_attr::W) writer structure"]
impl crate::Writable for TCD1_ATTR {}
#[doc = "TCD Transfer Attributes"]
pub mod tcd1_attr;
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_nbytes_mlno](tcd1_nbytes_mlno) module"]
pub type TCD1_NBYTES_MLNO = crate::Reg<u32, _TCD1_NBYTES_MLNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_NBYTES_MLNO;
#[doc = "`read()` method returns [tcd1_nbytes_mlno::R](tcd1_nbytes_mlno::R) reader structure"]
impl crate::Readable for TCD1_NBYTES_MLNO {}
#[doc = "`write(|w| ..)` method takes [tcd1_nbytes_mlno::W](tcd1_nbytes_mlno::W) writer structure"]
impl crate::Writable for TCD1_NBYTES_MLNO {}
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
pub mod tcd1_nbytes_mlno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_nbytes_mloffno](tcd1_nbytes_mloffno) module"]
pub type TCD1_NBYTES_MLOFFNO = crate::Reg<u32, _TCD1_NBYTES_MLOFFNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_NBYTES_MLOFFNO;
#[doc = "`read()` method returns [tcd1_nbytes_mloffno::R](tcd1_nbytes_mloffno::R) reader structure"]
impl crate::Readable for TCD1_NBYTES_MLOFFNO {}
#[doc = "`write(|w| ..)` method takes [tcd1_nbytes_mloffno::W](tcd1_nbytes_mloffno::W) writer structure"]
impl crate::Writable for TCD1_NBYTES_MLOFFNO {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
pub mod tcd1_nbytes_mloffno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_nbytes_mloffyes](tcd1_nbytes_mloffyes) module"]
pub type TCD1_NBYTES_MLOFFYES = crate::Reg<u32, _TCD1_NBYTES_MLOFFYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_NBYTES_MLOFFYES;
#[doc = "`read()` method returns [tcd1_nbytes_mloffyes::R](tcd1_nbytes_mloffyes::R) reader structure"]
impl crate::Readable for TCD1_NBYTES_MLOFFYES {}
#[doc = "`write(|w| ..)` method takes [tcd1_nbytes_mloffyes::W](tcd1_nbytes_mloffyes::W) writer structure"]
impl crate::Writable for TCD1_NBYTES_MLOFFYES {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
pub mod tcd1_nbytes_mloffyes;
#[doc = "TCD Last Source Address Adjustment\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_slast](tcd1_slast) module"]
pub type TCD1_SLAST = crate::Reg<u32, _TCD1_SLAST>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_SLAST;
#[doc = "`read()` method returns [tcd1_slast::R](tcd1_slast::R) reader structure"]
impl crate::Readable for TCD1_SLAST {}
#[doc = "`write(|w| ..)` method takes [tcd1_slast::W](tcd1_slast::W) writer structure"]
impl crate::Writable for TCD1_SLAST {}
#[doc = "TCD Last Source Address Adjustment"]
pub mod tcd1_slast;
#[doc = "TCD Destination Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_daddr](tcd1_daddr) module"]
pub type TCD1_DADDR = crate::Reg<u32, _TCD1_DADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_DADDR;
#[doc = "`read()` method returns [tcd1_daddr::R](tcd1_daddr::R) reader structure"]
impl crate::Readable for TCD1_DADDR {}
#[doc = "`write(|w| ..)` method takes [tcd1_daddr::W](tcd1_daddr::W) writer structure"]
impl crate::Writable for TCD1_DADDR {}
#[doc = "TCD Destination Address"]
pub mod tcd1_daddr;
#[doc = "TCD Signed Destination Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_doff](tcd1_doff) module"]
pub type TCD1_DOFF = crate::Reg<u16, _TCD1_DOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_DOFF;
#[doc = "`read()` method returns [tcd1_doff::R](tcd1_doff::R) reader structure"]
impl crate::Readable for TCD1_DOFF {}
#[doc = "`write(|w| ..)` method takes [tcd1_doff::W](tcd1_doff::W) writer structure"]
impl crate::Writable for TCD1_DOFF {}
#[doc = "TCD Signed Destination Address Offset"]
pub mod tcd1_doff;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_citer_elinkno](tcd1_citer_elinkno) module"]
pub type TCD1_CITER_ELINKNO = crate::Reg<u16, _TCD1_CITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_CITER_ELINKNO;
#[doc = "`read()` method returns [tcd1_citer_elinkno::R](tcd1_citer_elinkno::R) reader structure"]
impl crate::Readable for TCD1_CITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd1_citer_elinkno::W](tcd1_citer_elinkno::W) writer structure"]
impl crate::Writable for TCD1_CITER_ELINKNO {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd1_citer_elinkno;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_citer_elinkyes](tcd1_citer_elinkyes) module"]
pub type TCD1_CITER_ELINKYES = crate::Reg<u16, _TCD1_CITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_CITER_ELINKYES;
#[doc = "`read()` method returns [tcd1_citer_elinkyes::R](tcd1_citer_elinkyes::R) reader structure"]
impl crate::Readable for TCD1_CITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd1_citer_elinkyes::W](tcd1_citer_elinkyes::W) writer structure"]
impl crate::Writable for TCD1_CITER_ELINKYES {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd1_citer_elinkyes;
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_dlastsga](tcd1_dlastsga) module"]
pub type TCD1_DLASTSGA = crate::Reg<u32, _TCD1_DLASTSGA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_DLASTSGA;
#[doc = "`read()` method returns [tcd1_dlastsga::R](tcd1_dlastsga::R) reader structure"]
impl crate::Readable for TCD1_DLASTSGA {}
#[doc = "`write(|w| ..)` method takes [tcd1_dlastsga::W](tcd1_dlastsga::W) writer structure"]
impl crate::Writable for TCD1_DLASTSGA {}
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address"]
pub mod tcd1_dlastsga;
#[doc = "TCD Control and Status\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_csr](tcd1_csr) module"]
pub type TCD1_CSR = crate::Reg<u16, _TCD1_CSR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_CSR;
#[doc = "`read()` method returns [tcd1_csr::R](tcd1_csr::R) reader structure"]
impl crate::Readable for TCD1_CSR {}
#[doc = "`write(|w| ..)` method takes [tcd1_csr::W](tcd1_csr::W) writer structure"]
impl crate::Writable for TCD1_CSR {}
#[doc = "TCD Control and Status"]
pub mod tcd1_csr;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_biter_elinkno](tcd1_biter_elinkno) module"]
pub type TCD1_BITER_ELINKNO = crate::Reg<u16, _TCD1_BITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_BITER_ELINKNO;
#[doc = "`read()` method returns [tcd1_biter_elinkno::R](tcd1_biter_elinkno::R) reader structure"]
impl crate::Readable for TCD1_BITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd1_biter_elinkno::W](tcd1_biter_elinkno::W) writer structure"]
impl crate::Writable for TCD1_BITER_ELINKNO {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd1_biter_elinkno;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd1_biter_elinkyes](tcd1_biter_elinkyes) module"]
pub type TCD1_BITER_ELINKYES = crate::Reg<u16, _TCD1_BITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD1_BITER_ELINKYES;
#[doc = "`read()` method returns [tcd1_biter_elinkyes::R](tcd1_biter_elinkyes::R) reader structure"]
impl crate::Readable for TCD1_BITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd1_biter_elinkyes::W](tcd1_biter_elinkyes::W) writer structure"]
impl crate::Writable for TCD1_BITER_ELINKYES {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd1_biter_elinkyes;
#[doc = "TCD Source Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_saddr](tcd2_saddr) module"]
pub type TCD2_SADDR = crate::Reg<u32, _TCD2_SADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_SADDR;
#[doc = "`read()` method returns [tcd2_saddr::R](tcd2_saddr::R) reader structure"]
impl crate::Readable for TCD2_SADDR {}
#[doc = "`write(|w| ..)` method takes [tcd2_saddr::W](tcd2_saddr::W) writer structure"]
impl crate::Writable for TCD2_SADDR {}
#[doc = "TCD Source Address"]
pub mod tcd2_saddr;
#[doc = "TCD Signed Source Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_soff](tcd2_soff) module"]
pub type TCD2_SOFF = crate::Reg<u16, _TCD2_SOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_SOFF;
#[doc = "`read()` method returns [tcd2_soff::R](tcd2_soff::R) reader structure"]
impl crate::Readable for TCD2_SOFF {}
#[doc = "`write(|w| ..)` method takes [tcd2_soff::W](tcd2_soff::W) writer structure"]
impl crate::Writable for TCD2_SOFF {}
#[doc = "TCD Signed Source Address Offset"]
pub mod tcd2_soff;
#[doc = "TCD Transfer Attributes\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_attr](tcd2_attr) module"]
pub type TCD2_ATTR = crate::Reg<u16, _TCD2_ATTR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_ATTR;
#[doc = "`read()` method returns [tcd2_attr::R](tcd2_attr::R) reader structure"]
impl crate::Readable for TCD2_ATTR {}
#[doc = "`write(|w| ..)` method takes [tcd2_attr::W](tcd2_attr::W) writer structure"]
impl crate::Writable for TCD2_ATTR {}
#[doc = "TCD Transfer Attributes"]
pub mod tcd2_attr;
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_nbytes_mlno](tcd2_nbytes_mlno) module"]
pub type TCD2_NBYTES_MLNO = crate::Reg<u32, _TCD2_NBYTES_MLNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_NBYTES_MLNO;
#[doc = "`read()` method returns [tcd2_nbytes_mlno::R](tcd2_nbytes_mlno::R) reader structure"]
impl crate::Readable for TCD2_NBYTES_MLNO {}
#[doc = "`write(|w| ..)` method takes [tcd2_nbytes_mlno::W](tcd2_nbytes_mlno::W) writer structure"]
impl crate::Writable for TCD2_NBYTES_MLNO {}
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
pub mod tcd2_nbytes_mlno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_nbytes_mloffno](tcd2_nbytes_mloffno) module"]
pub type TCD2_NBYTES_MLOFFNO = crate::Reg<u32, _TCD2_NBYTES_MLOFFNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_NBYTES_MLOFFNO;
#[doc = "`read()` method returns [tcd2_nbytes_mloffno::R](tcd2_nbytes_mloffno::R) reader structure"]
impl crate::Readable for TCD2_NBYTES_MLOFFNO {}
#[doc = "`write(|w| ..)` method takes [tcd2_nbytes_mloffno::W](tcd2_nbytes_mloffno::W) writer structure"]
impl crate::Writable for TCD2_NBYTES_MLOFFNO {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
pub mod tcd2_nbytes_mloffno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_nbytes_mloffyes](tcd2_nbytes_mloffyes) module"]
pub type TCD2_NBYTES_MLOFFYES = crate::Reg<u32, _TCD2_NBYTES_MLOFFYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_NBYTES_MLOFFYES;
#[doc = "`read()` method returns [tcd2_nbytes_mloffyes::R](tcd2_nbytes_mloffyes::R) reader structure"]
impl crate::Readable for TCD2_NBYTES_MLOFFYES {}
#[doc = "`write(|w| ..)` method takes [tcd2_nbytes_mloffyes::W](tcd2_nbytes_mloffyes::W) writer structure"]
impl crate::Writable for TCD2_NBYTES_MLOFFYES {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
pub mod tcd2_nbytes_mloffyes;
#[doc = "TCD Last Source Address Adjustment\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_slast](tcd2_slast) module"]
pub type TCD2_SLAST = crate::Reg<u32, _TCD2_SLAST>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_SLAST;
#[doc = "`read()` method returns [tcd2_slast::R](tcd2_slast::R) reader structure"]
impl crate::Readable for TCD2_SLAST {}
#[doc = "`write(|w| ..)` method takes [tcd2_slast::W](tcd2_slast::W) writer structure"]
impl crate::Writable for TCD2_SLAST {}
#[doc = "TCD Last Source Address Adjustment"]
pub mod tcd2_slast;
#[doc = "TCD Destination Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_daddr](tcd2_daddr) module"]
pub type TCD2_DADDR = crate::Reg<u32, _TCD2_DADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_DADDR;
#[doc = "`read()` method returns [tcd2_daddr::R](tcd2_daddr::R) reader structure"]
impl crate::Readable for TCD2_DADDR {}
#[doc = "`write(|w| ..)` method takes [tcd2_daddr::W](tcd2_daddr::W) writer structure"]
impl crate::Writable for TCD2_DADDR {}
#[doc = "TCD Destination Address"]
pub mod tcd2_daddr;
#[doc = "TCD Signed Destination Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_doff](tcd2_doff) module"]
pub type TCD2_DOFF = crate::Reg<u16, _TCD2_DOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_DOFF;
#[doc = "`read()` method returns [tcd2_doff::R](tcd2_doff::R) reader structure"]
impl crate::Readable for TCD2_DOFF {}
#[doc = "`write(|w| ..)` method takes [tcd2_doff::W](tcd2_doff::W) writer structure"]
impl crate::Writable for TCD2_DOFF {}
#[doc = "TCD Signed Destination Address Offset"]
pub mod tcd2_doff;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_citer_elinkno](tcd2_citer_elinkno) module"]
pub type TCD2_CITER_ELINKNO = crate::Reg<u16, _TCD2_CITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_CITER_ELINKNO;
#[doc = "`read()` method returns [tcd2_citer_elinkno::R](tcd2_citer_elinkno::R) reader structure"]
impl crate::Readable for TCD2_CITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd2_citer_elinkno::W](tcd2_citer_elinkno::W) writer structure"]
impl crate::Writable for TCD2_CITER_ELINKNO {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd2_citer_elinkno;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_citer_elinkyes](tcd2_citer_elinkyes) module"]
pub type TCD2_CITER_ELINKYES = crate::Reg<u16, _TCD2_CITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_CITER_ELINKYES;
#[doc = "`read()` method returns [tcd2_citer_elinkyes::R](tcd2_citer_elinkyes::R) reader structure"]
impl crate::Readable for TCD2_CITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd2_citer_elinkyes::W](tcd2_citer_elinkyes::W) writer structure"]
impl crate::Writable for TCD2_CITER_ELINKYES {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd2_citer_elinkyes;
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_dlastsga](tcd2_dlastsga) module"]
pub type TCD2_DLASTSGA = crate::Reg<u32, _TCD2_DLASTSGA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_DLASTSGA;
#[doc = "`read()` method returns [tcd2_dlastsga::R](tcd2_dlastsga::R) reader structure"]
impl crate::Readable for TCD2_DLASTSGA {}
#[doc = "`write(|w| ..)` method takes [tcd2_dlastsga::W](tcd2_dlastsga::W) writer structure"]
impl crate::Writable for TCD2_DLASTSGA {}
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address"]
pub mod tcd2_dlastsga;
#[doc = "TCD Control and Status\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_csr](tcd2_csr) module"]
pub type TCD2_CSR = crate::Reg<u16, _TCD2_CSR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_CSR;
#[doc = "`read()` method returns [tcd2_csr::R](tcd2_csr::R) reader structure"]
impl crate::Readable for TCD2_CSR {}
#[doc = "`write(|w| ..)` method takes [tcd2_csr::W](tcd2_csr::W) writer structure"]
impl crate::Writable for TCD2_CSR {}
#[doc = "TCD Control and Status"]
pub mod tcd2_csr;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_biter_elinkno](tcd2_biter_elinkno) module"]
pub type TCD2_BITER_ELINKNO = crate::Reg<u16, _TCD2_BITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_BITER_ELINKNO;
#[doc = "`read()` method returns [tcd2_biter_elinkno::R](tcd2_biter_elinkno::R) reader structure"]
impl crate::Readable for TCD2_BITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd2_biter_elinkno::W](tcd2_biter_elinkno::W) writer structure"]
impl crate::Writable for TCD2_BITER_ELINKNO {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd2_biter_elinkno;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd2_biter_elinkyes](tcd2_biter_elinkyes) module"]
pub type TCD2_BITER_ELINKYES = crate::Reg<u16, _TCD2_BITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD2_BITER_ELINKYES;
#[doc = "`read()` method returns [tcd2_biter_elinkyes::R](tcd2_biter_elinkyes::R) reader structure"]
impl crate::Readable for TCD2_BITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd2_biter_elinkyes::W](tcd2_biter_elinkyes::W) writer structure"]
impl crate::Writable for TCD2_BITER_ELINKYES {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd2_biter_elinkyes;
#[doc = "TCD Source Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_saddr](tcd3_saddr) module"]
pub type TCD3_SADDR = crate::Reg<u32, _TCD3_SADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_SADDR;
#[doc = "`read()` method returns [tcd3_saddr::R](tcd3_saddr::R) reader structure"]
impl crate::Readable for TCD3_SADDR {}
#[doc = "`write(|w| ..)` method takes [tcd3_saddr::W](tcd3_saddr::W) writer structure"]
impl crate::Writable for TCD3_SADDR {}
#[doc = "TCD Source Address"]
pub mod tcd3_saddr;
#[doc = "TCD Signed Source Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_soff](tcd3_soff) module"]
pub type TCD3_SOFF = crate::Reg<u16, _TCD3_SOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_SOFF;
#[doc = "`read()` method returns [tcd3_soff::R](tcd3_soff::R) reader structure"]
impl crate::Readable for TCD3_SOFF {}
#[doc = "`write(|w| ..)` method takes [tcd3_soff::W](tcd3_soff::W) writer structure"]
impl crate::Writable for TCD3_SOFF {}
#[doc = "TCD Signed Source Address Offset"]
pub mod tcd3_soff;
#[doc = "TCD Transfer Attributes\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_attr](tcd3_attr) module"]
pub type TCD3_ATTR = crate::Reg<u16, _TCD3_ATTR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_ATTR;
#[doc = "`read()` method returns [tcd3_attr::R](tcd3_attr::R) reader structure"]
impl crate::Readable for TCD3_ATTR {}
#[doc = "`write(|w| ..)` method takes [tcd3_attr::W](tcd3_attr::W) writer structure"]
impl crate::Writable for TCD3_ATTR {}
#[doc = "TCD Transfer Attributes"]
pub mod tcd3_attr;
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_nbytes_mlno](tcd3_nbytes_mlno) module"]
pub type TCD3_NBYTES_MLNO = crate::Reg<u32, _TCD3_NBYTES_MLNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_NBYTES_MLNO;
#[doc = "`read()` method returns [tcd3_nbytes_mlno::R](tcd3_nbytes_mlno::R) reader structure"]
impl crate::Readable for TCD3_NBYTES_MLNO {}
#[doc = "`write(|w| ..)` method takes [tcd3_nbytes_mlno::W](tcd3_nbytes_mlno::W) writer structure"]
impl crate::Writable for TCD3_NBYTES_MLNO {}
#[doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)"]
pub mod tcd3_nbytes_mlno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_nbytes_mloffno](tcd3_nbytes_mloffno) module"]
pub type TCD3_NBYTES_MLOFFNO = crate::Reg<u32, _TCD3_NBYTES_MLOFFNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_NBYTES_MLOFFNO;
#[doc = "`read()` method returns [tcd3_nbytes_mloffno::R](tcd3_nbytes_mloffno::R) reader structure"]
impl crate::Readable for TCD3_NBYTES_MLOFFNO {}
#[doc = "`write(|w| ..)` method takes [tcd3_nbytes_mloffno::W](tcd3_nbytes_mloffno::W) writer structure"]
impl crate::Writable for TCD3_NBYTES_MLOFFNO {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)"]
pub mod tcd3_nbytes_mloffno;
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_nbytes_mloffyes](tcd3_nbytes_mloffyes) module"]
pub type TCD3_NBYTES_MLOFFYES = crate::Reg<u32, _TCD3_NBYTES_MLOFFYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_NBYTES_MLOFFYES;
#[doc = "`read()` method returns [tcd3_nbytes_mloffyes::R](tcd3_nbytes_mloffyes::R) reader structure"]
impl crate::Readable for TCD3_NBYTES_MLOFFYES {}
#[doc = "`write(|w| ..)` method takes [tcd3_nbytes_mloffyes::W](tcd3_nbytes_mloffyes::W) writer structure"]
impl crate::Writable for TCD3_NBYTES_MLOFFYES {}
#[doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)"]
pub mod tcd3_nbytes_mloffyes;
#[doc = "TCD Last Source Address Adjustment\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_slast](tcd3_slast) module"]
pub type TCD3_SLAST = crate::Reg<u32, _TCD3_SLAST>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_SLAST;
#[doc = "`read()` method returns [tcd3_slast::R](tcd3_slast::R) reader structure"]
impl crate::Readable for TCD3_SLAST {}
#[doc = "`write(|w| ..)` method takes [tcd3_slast::W](tcd3_slast::W) writer structure"]
impl crate::Writable for TCD3_SLAST {}
#[doc = "TCD Last Source Address Adjustment"]
pub mod tcd3_slast;
#[doc = "TCD Destination Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_daddr](tcd3_daddr) module"]
pub type TCD3_DADDR = crate::Reg<u32, _TCD3_DADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_DADDR;
#[doc = "`read()` method returns [tcd3_daddr::R](tcd3_daddr::R) reader structure"]
impl crate::Readable for TCD3_DADDR {}
#[doc = "`write(|w| ..)` method takes [tcd3_daddr::W](tcd3_daddr::W) writer structure"]
impl crate::Writable for TCD3_DADDR {}
#[doc = "TCD Destination Address"]
pub mod tcd3_daddr;
#[doc = "TCD Signed Destination Address Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_doff](tcd3_doff) module"]
pub type TCD3_DOFF = crate::Reg<u16, _TCD3_DOFF>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_DOFF;
#[doc = "`read()` method returns [tcd3_doff::R](tcd3_doff::R) reader structure"]
impl crate::Readable for TCD3_DOFF {}
#[doc = "`write(|w| ..)` method takes [tcd3_doff::W](tcd3_doff::W) writer structure"]
impl crate::Writable for TCD3_DOFF {}
#[doc = "TCD Signed Destination Address Offset"]
pub mod tcd3_doff;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_citer_elinkno](tcd3_citer_elinkno) module"]
pub type TCD3_CITER_ELINKNO = crate::Reg<u16, _TCD3_CITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_CITER_ELINKNO;
#[doc = "`read()` method returns [tcd3_citer_elinkno::R](tcd3_citer_elinkno::R) reader structure"]
impl crate::Readable for TCD3_CITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd3_citer_elinkno::W](tcd3_citer_elinkno::W) writer structure"]
impl crate::Writable for TCD3_CITER_ELINKNO {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd3_citer_elinkno;
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_citer_elinkyes](tcd3_citer_elinkyes) module"]
pub type TCD3_CITER_ELINKYES = crate::Reg<u16, _TCD3_CITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_CITER_ELINKYES;
#[doc = "`read()` method returns [tcd3_citer_elinkyes::R](tcd3_citer_elinkyes::R) reader structure"]
impl crate::Readable for TCD3_CITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd3_citer_elinkyes::W](tcd3_citer_elinkyes::W) writer structure"]
impl crate::Writable for TCD3_CITER_ELINKYES {}
#[doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd3_citer_elinkyes;
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_dlastsga](tcd3_dlastsga) module"]
pub type TCD3_DLASTSGA = crate::Reg<u32, _TCD3_DLASTSGA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_DLASTSGA;
#[doc = "`read()` method returns [tcd3_dlastsga::R](tcd3_dlastsga::R) reader structure"]
impl crate::Readable for TCD3_DLASTSGA {}
#[doc = "`write(|w| ..)` method takes [tcd3_dlastsga::W](tcd3_dlastsga::W) writer structure"]
impl crate::Writable for TCD3_DLASTSGA {}
#[doc = "TCD Last Destination Address Adjustment/Scatter Gather Address"]
pub mod tcd3_dlastsga;
#[doc = "TCD Control and Status\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_csr](tcd3_csr) module"]
pub type TCD3_CSR = crate::Reg<u16, _TCD3_CSR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_CSR;
#[doc = "`read()` method returns [tcd3_csr::R](tcd3_csr::R) reader structure"]
impl crate::Readable for TCD3_CSR {}
#[doc = "`write(|w| ..)` method takes [tcd3_csr::W](tcd3_csr::W) writer structure"]
impl crate::Writable for TCD3_CSR {}
#[doc = "TCD Control and Status"]
pub mod tcd3_csr;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_biter_elinkno](tcd3_biter_elinkno) module"]
pub type TCD3_BITER_ELINKNO = crate::Reg<u16, _TCD3_BITER_ELINKNO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_BITER_ELINKNO;
#[doc = "`read()` method returns [tcd3_biter_elinkno::R](tcd3_biter_elinkno::R) reader structure"]
impl crate::Readable for TCD3_BITER_ELINKNO {}
#[doc = "`write(|w| ..)` method takes [tcd3_biter_elinkno::W](tcd3_biter_elinkno::W) writer structure"]
impl crate::Writable for TCD3_BITER_ELINKNO {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)"]
pub mod tcd3_biter_elinkno;
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcd3_biter_elinkyes](tcd3_biter_elinkyes) module"]
pub type TCD3_BITER_ELINKYES = crate::Reg<u16, _TCD3_BITER_ELINKYES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCD3_BITER_ELINKYES;
#[doc = "`read()` method returns [tcd3_biter_elinkyes::R](tcd3_biter_elinkyes::R) reader structure"]
impl crate::Readable for TCD3_BITER_ELINKYES {}
#[doc = "`write(|w| ..)` method takes [tcd3_biter_elinkyes::W](tcd3_biter_elinkyes::W) writer structure"]
impl crate::Writable for TCD3_BITER_ELINKYES {}
#[doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)"]
pub mod tcd3_biter_elinkyes;
