#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Interrupt Set Enable Register"]
    pub s32_nvic_iser: S32_NVIC_ISER,
    _reserved1: [u8; 124usize],
    #[doc = "0x80 - Interrupt Clear Enable Register"]
    pub s32_nvic_icer: S32_NVIC_ICER,
    _reserved2: [u8; 124usize],
    #[doc = "0x100 - Interrupt Set Pending Register"]
    pub s32_nvic_ispr: S32_NVIC_ISPR,
    _reserved3: [u8; 124usize],
    #[doc = "0x180 - Interrupt Clear Pending Register"]
    pub s32_nvic_icpr: S32_NVIC_ICPR,
    _reserved4: [u8; 380usize],
    #[doc = "0x300 - Interrupt Priority Register n"]
    pub s32_nvic_ipr0: S32_NVIC_IPR0,
    #[doc = "0x304 - Interrupt Priority Register n"]
    pub s32_nvic_ipr1: S32_NVIC_IPR1,
    #[doc = "0x308 - Interrupt Priority Register n"]
    pub s32_nvic_ipr2: S32_NVIC_IPR2,
    #[doc = "0x30c - Interrupt Priority Register n"]
    pub s32_nvic_ipr3: S32_NVIC_IPR3,
    #[doc = "0x310 - Interrupt Priority Register n"]
    pub s32_nvic_ipr4: S32_NVIC_IPR4,
    #[doc = "0x314 - Interrupt Priority Register n"]
    pub s32_nvic_ipr5: S32_NVIC_IPR5,
    #[doc = "0x318 - Interrupt Priority Register n"]
    pub s32_nvic_ipr6: S32_NVIC_IPR6,
    #[doc = "0x31c - Interrupt Priority Register n"]
    pub s32_nvic_ipr7: S32_NVIC_IPR7,
}
#[doc = "Interrupt Set Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_iser](s32_nvic_iser) module"]
pub type S32_NVIC_ISER = crate::Reg<u32, _S32_NVIC_ISER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_ISER;
#[doc = "`read()` method returns [s32_nvic_iser::R](s32_nvic_iser::R) reader structure"]
impl crate::Readable for S32_NVIC_ISER {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_iser::W](s32_nvic_iser::W) writer structure"]
impl crate::Writable for S32_NVIC_ISER {}
#[doc = "Interrupt Set Enable Register"]
pub mod s32_nvic_iser;
#[doc = "Interrupt Clear Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_icer](s32_nvic_icer) module"]
pub type S32_NVIC_ICER = crate::Reg<u32, _S32_NVIC_ICER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_ICER;
#[doc = "`read()` method returns [s32_nvic_icer::R](s32_nvic_icer::R) reader structure"]
impl crate::Readable for S32_NVIC_ICER {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_icer::W](s32_nvic_icer::W) writer structure"]
impl crate::Writable for S32_NVIC_ICER {}
#[doc = "Interrupt Clear Enable Register"]
pub mod s32_nvic_icer;
#[doc = "Interrupt Set Pending Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ispr](s32_nvic_ispr) module"]
pub type S32_NVIC_ISPR = crate::Reg<u32, _S32_NVIC_ISPR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_ISPR;
#[doc = "`read()` method returns [s32_nvic_ispr::R](s32_nvic_ispr::R) reader structure"]
impl crate::Readable for S32_NVIC_ISPR {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ispr::W](s32_nvic_ispr::W) writer structure"]
impl crate::Writable for S32_NVIC_ISPR {}
#[doc = "Interrupt Set Pending Register"]
pub mod s32_nvic_ispr;
#[doc = "Interrupt Clear Pending Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_icpr](s32_nvic_icpr) module"]
pub type S32_NVIC_ICPR = crate::Reg<u32, _S32_NVIC_ICPR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_ICPR;
#[doc = "`read()` method returns [s32_nvic_icpr::R](s32_nvic_icpr::R) reader structure"]
impl crate::Readable for S32_NVIC_ICPR {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_icpr::W](s32_nvic_icpr::W) writer structure"]
impl crate::Writable for S32_NVIC_ICPR {}
#[doc = "Interrupt Clear Pending Register"]
pub mod s32_nvic_icpr;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr0](s32_nvic_ipr0) module"]
pub type S32_NVIC_IPR0 = crate::Reg<u32, _S32_NVIC_IPR0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR0;
#[doc = "`read()` method returns [s32_nvic_ipr0::R](s32_nvic_ipr0::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR0 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr0::W](s32_nvic_ipr0::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR0 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr0;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr1](s32_nvic_ipr1) module"]
pub type S32_NVIC_IPR1 = crate::Reg<u32, _S32_NVIC_IPR1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR1;
#[doc = "`read()` method returns [s32_nvic_ipr1::R](s32_nvic_ipr1::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR1 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr1::W](s32_nvic_ipr1::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR1 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr1;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr2](s32_nvic_ipr2) module"]
pub type S32_NVIC_IPR2 = crate::Reg<u32, _S32_NVIC_IPR2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR2;
#[doc = "`read()` method returns [s32_nvic_ipr2::R](s32_nvic_ipr2::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR2 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr2::W](s32_nvic_ipr2::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR2 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr2;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr3](s32_nvic_ipr3) module"]
pub type S32_NVIC_IPR3 = crate::Reg<u32, _S32_NVIC_IPR3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR3;
#[doc = "`read()` method returns [s32_nvic_ipr3::R](s32_nvic_ipr3::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR3 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr3::W](s32_nvic_ipr3::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR3 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr3;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr4](s32_nvic_ipr4) module"]
pub type S32_NVIC_IPR4 = crate::Reg<u32, _S32_NVIC_IPR4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR4;
#[doc = "`read()` method returns [s32_nvic_ipr4::R](s32_nvic_ipr4::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR4 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr4::W](s32_nvic_ipr4::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR4 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr4;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr5](s32_nvic_ipr5) module"]
pub type S32_NVIC_IPR5 = crate::Reg<u32, _S32_NVIC_IPR5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR5;
#[doc = "`read()` method returns [s32_nvic_ipr5::R](s32_nvic_ipr5::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR5 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr5::W](s32_nvic_ipr5::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR5 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr5;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr6](s32_nvic_ipr6) module"]
pub type S32_NVIC_IPR6 = crate::Reg<u32, _S32_NVIC_IPR6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR6;
#[doc = "`read()` method returns [s32_nvic_ipr6::R](s32_nvic_ipr6::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR6 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr6::W](s32_nvic_ipr6::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR6 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr6;
#[doc = "Interrupt Priority Register n\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [s32_nvic_ipr7](s32_nvic_ipr7) module"]
pub type S32_NVIC_IPR7 = crate::Reg<u32, _S32_NVIC_IPR7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _S32_NVIC_IPR7;
#[doc = "`read()` method returns [s32_nvic_ipr7::R](s32_nvic_ipr7::R) reader structure"]
impl crate::Readable for S32_NVIC_IPR7 {}
#[doc = "`write(|w| ..)` method takes [s32_nvic_ipr7::W](s32_nvic_ipr7::W) writer structure"]
impl crate::Writable for S32_NVIC_IPR7 {}
#[doc = "Interrupt Priority Register n"]
pub mod s32_nvic_ipr7;
