#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Module Configuration Register"]
    pub mcr: MCR,
    #[doc = "0x04 - Control 1 register"]
    pub ctrl1: CTRL1,
    #[doc = "0x08 - Free Running Timer"]
    pub timer: TIMER,
    _reserved3: [u8; 4usize],
    #[doc = "0x10 - Rx Mailboxes Global Mask Register"]
    pub rxmgmask: RXMGMASK,
    #[doc = "0x14 - Rx 14 Mask register"]
    pub rx14mask: RX14MASK,
    #[doc = "0x18 - Rx 15 Mask register"]
    pub rx15mask: RX15MASK,
    #[doc = "0x1c - Error Counter"]
    pub ecr: ECR,
    #[doc = "0x20 - Error and Status 1 register"]
    pub esr1: ESR1,
    _reserved8: [u8; 4usize],
    #[doc = "0x28 - Interrupt Masks 1 register"]
    pub imask1: IMASK1,
    _reserved9: [u8; 4usize],
    #[doc = "0x30 - Interrupt Flags 1 register"]
    pub iflag1: IFLAG1,
    #[doc = "0x34 - Control 2 register"]
    pub ctrl2: CTRL2,
    #[doc = "0x38 - Error and Status 2 register"]
    pub esr2: ESR2,
    _reserved12: [u8; 8usize],
    #[doc = "0x44 - CRC Register"]
    pub crcr: CRCR,
    #[doc = "0x48 - Rx FIFO Global Mask register"]
    pub rxfgmask: RXFGMASK,
    #[doc = "0x4c - Rx FIFO Information Register"]
    pub rxfir: RXFIR,
    #[doc = "0x50 - CAN Bit Timing Register"]
    pub cbt: CBT,
    _reserved16: [u8; 44usize],
    #[doc = "0x80 - Embedded RAM"]
    pub ramn0: RAMN0,
    #[doc = "0x84 - Embedded RAM"]
    pub ramn1: RAMN1,
    #[doc = "0x88 - Embedded RAM"]
    pub ramn2: RAMN2,
    #[doc = "0x8c - Embedded RAM"]
    pub ramn3: RAMN3,
    #[doc = "0x90 - Embedded RAM"]
    pub ramn4: RAMN4,
    #[doc = "0x94 - Embedded RAM"]
    pub ramn5: RAMN5,
    #[doc = "0x98 - Embedded RAM"]
    pub ramn6: RAMN6,
    #[doc = "0x9c - Embedded RAM"]
    pub ramn7: RAMN7,
    #[doc = "0xa0 - Embedded RAM"]
    pub ramn8: RAMN8,
    #[doc = "0xa4 - Embedded RAM"]
    pub ramn9: RAMN9,
    #[doc = "0xa8 - Embedded RAM"]
    pub ramn10: RAMN10,
    #[doc = "0xac - Embedded RAM"]
    pub ramn11: RAMN11,
    #[doc = "0xb0 - Embedded RAM"]
    pub ramn12: RAMN12,
    #[doc = "0xb4 - Embedded RAM"]
    pub ramn13: RAMN13,
    #[doc = "0xb8 - Embedded RAM"]
    pub ramn14: RAMN14,
    #[doc = "0xbc - Embedded RAM"]
    pub ramn15: RAMN15,
    #[doc = "0xc0 - Embedded RAM"]
    pub ramn16: RAMN16,
    #[doc = "0xc4 - Embedded RAM"]
    pub ramn17: RAMN17,
    #[doc = "0xc8 - Embedded RAM"]
    pub ramn18: RAMN18,
    #[doc = "0xcc - Embedded RAM"]
    pub ramn19: RAMN19,
    #[doc = "0xd0 - Embedded RAM"]
    pub ramn20: RAMN20,
    #[doc = "0xd4 - Embedded RAM"]
    pub ramn21: RAMN21,
    #[doc = "0xd8 - Embedded RAM"]
    pub ramn22: RAMN22,
    #[doc = "0xdc - Embedded RAM"]
    pub ramn23: RAMN23,
    #[doc = "0xe0 - Embedded RAM"]
    pub ramn24: RAMN24,
    #[doc = "0xe4 - Embedded RAM"]
    pub ramn25: RAMN25,
    #[doc = "0xe8 - Embedded RAM"]
    pub ramn26: RAMN26,
    #[doc = "0xec - Embedded RAM"]
    pub ramn27: RAMN27,
    #[doc = "0xf0 - Embedded RAM"]
    pub ramn28: RAMN28,
    #[doc = "0xf4 - Embedded RAM"]
    pub ramn29: RAMN29,
    #[doc = "0xf8 - Embedded RAM"]
    pub ramn30: RAMN30,
    #[doc = "0xfc - Embedded RAM"]
    pub ramn31: RAMN31,
    #[doc = "0x100 - Embedded RAM"]
    pub ramn32: RAMN32,
    #[doc = "0x104 - Embedded RAM"]
    pub ramn33: RAMN33,
    #[doc = "0x108 - Embedded RAM"]
    pub ramn34: RAMN34,
    #[doc = "0x10c - Embedded RAM"]
    pub ramn35: RAMN35,
    #[doc = "0x110 - Embedded RAM"]
    pub ramn36: RAMN36,
    #[doc = "0x114 - Embedded RAM"]
    pub ramn37: RAMN37,
    #[doc = "0x118 - Embedded RAM"]
    pub ramn38: RAMN38,
    #[doc = "0x11c - Embedded RAM"]
    pub ramn39: RAMN39,
    #[doc = "0x120 - Embedded RAM"]
    pub ramn40: RAMN40,
    #[doc = "0x124 - Embedded RAM"]
    pub ramn41: RAMN41,
    #[doc = "0x128 - Embedded RAM"]
    pub ramn42: RAMN42,
    #[doc = "0x12c - Embedded RAM"]
    pub ramn43: RAMN43,
    #[doc = "0x130 - Embedded RAM"]
    pub ramn44: RAMN44,
    #[doc = "0x134 - Embedded RAM"]
    pub ramn45: RAMN45,
    #[doc = "0x138 - Embedded RAM"]
    pub ramn46: RAMN46,
    #[doc = "0x13c - Embedded RAM"]
    pub ramn47: RAMN47,
    #[doc = "0x140 - Embedded RAM"]
    pub ramn48: RAMN48,
    #[doc = "0x144 - Embedded RAM"]
    pub ramn49: RAMN49,
    #[doc = "0x148 - Embedded RAM"]
    pub ramn50: RAMN50,
    #[doc = "0x14c - Embedded RAM"]
    pub ramn51: RAMN51,
    #[doc = "0x150 - Embedded RAM"]
    pub ramn52: RAMN52,
    #[doc = "0x154 - Embedded RAM"]
    pub ramn53: RAMN53,
    #[doc = "0x158 - Embedded RAM"]
    pub ramn54: RAMN54,
    #[doc = "0x15c - Embedded RAM"]
    pub ramn55: RAMN55,
    #[doc = "0x160 - Embedded RAM"]
    pub ramn56: RAMN56,
    #[doc = "0x164 - Embedded RAM"]
    pub ramn57: RAMN57,
    #[doc = "0x168 - Embedded RAM"]
    pub ramn58: RAMN58,
    #[doc = "0x16c - Embedded RAM"]
    pub ramn59: RAMN59,
    #[doc = "0x170 - Embedded RAM"]
    pub ramn60: RAMN60,
    #[doc = "0x174 - Embedded RAM"]
    pub ramn61: RAMN61,
    #[doc = "0x178 - Embedded RAM"]
    pub ramn62: RAMN62,
    #[doc = "0x17c - Embedded RAM"]
    pub ramn63: RAMN63,
    #[doc = "0x180 - Embedded RAM"]
    pub ramn64: RAMN64,
    #[doc = "0x184 - Embedded RAM"]
    pub ramn65: RAMN65,
    #[doc = "0x188 - Embedded RAM"]
    pub ramn66: RAMN66,
    #[doc = "0x18c - Embedded RAM"]
    pub ramn67: RAMN67,
    #[doc = "0x190 - Embedded RAM"]
    pub ramn68: RAMN68,
    #[doc = "0x194 - Embedded RAM"]
    pub ramn69: RAMN69,
    #[doc = "0x198 - Embedded RAM"]
    pub ramn70: RAMN70,
    #[doc = "0x19c - Embedded RAM"]
    pub ramn71: RAMN71,
    #[doc = "0x1a0 - Embedded RAM"]
    pub ramn72: RAMN72,
    #[doc = "0x1a4 - Embedded RAM"]
    pub ramn73: RAMN73,
    #[doc = "0x1a8 - Embedded RAM"]
    pub ramn74: RAMN74,
    #[doc = "0x1ac - Embedded RAM"]
    pub ramn75: RAMN75,
    #[doc = "0x1b0 - Embedded RAM"]
    pub ramn76: RAMN76,
    #[doc = "0x1b4 - Embedded RAM"]
    pub ramn77: RAMN77,
    #[doc = "0x1b8 - Embedded RAM"]
    pub ramn78: RAMN78,
    #[doc = "0x1bc - Embedded RAM"]
    pub ramn79: RAMN79,
    #[doc = "0x1c0 - Embedded RAM"]
    pub ramn80: RAMN80,
    #[doc = "0x1c4 - Embedded RAM"]
    pub ramn81: RAMN81,
    #[doc = "0x1c8 - Embedded RAM"]
    pub ramn82: RAMN82,
    #[doc = "0x1cc - Embedded RAM"]
    pub ramn83: RAMN83,
    #[doc = "0x1d0 - Embedded RAM"]
    pub ramn84: RAMN84,
    #[doc = "0x1d4 - Embedded RAM"]
    pub ramn85: RAMN85,
    #[doc = "0x1d8 - Embedded RAM"]
    pub ramn86: RAMN86,
    #[doc = "0x1dc - Embedded RAM"]
    pub ramn87: RAMN87,
    #[doc = "0x1e0 - Embedded RAM"]
    pub ramn88: RAMN88,
    #[doc = "0x1e4 - Embedded RAM"]
    pub ramn89: RAMN89,
    #[doc = "0x1e8 - Embedded RAM"]
    pub ramn90: RAMN90,
    #[doc = "0x1ec - Embedded RAM"]
    pub ramn91: RAMN91,
    #[doc = "0x1f0 - Embedded RAM"]
    pub ramn92: RAMN92,
    #[doc = "0x1f4 - Embedded RAM"]
    pub ramn93: RAMN93,
    #[doc = "0x1f8 - Embedded RAM"]
    pub ramn94: RAMN94,
    #[doc = "0x1fc - Embedded RAM"]
    pub ramn95: RAMN95,
    #[doc = "0x200 - Embedded RAM"]
    pub ramn96: RAMN96,
    #[doc = "0x204 - Embedded RAM"]
    pub ramn97: RAMN97,
    #[doc = "0x208 - Embedded RAM"]
    pub ramn98: RAMN98,
    #[doc = "0x20c - Embedded RAM"]
    pub ramn99: RAMN99,
    #[doc = "0x210 - Embedded RAM"]
    pub ramn100: RAMN100,
    #[doc = "0x214 - Embedded RAM"]
    pub ramn101: RAMN101,
    #[doc = "0x218 - Embedded RAM"]
    pub ramn102: RAMN102,
    #[doc = "0x21c - Embedded RAM"]
    pub ramn103: RAMN103,
    #[doc = "0x220 - Embedded RAM"]
    pub ramn104: RAMN104,
    #[doc = "0x224 - Embedded RAM"]
    pub ramn105: RAMN105,
    #[doc = "0x228 - Embedded RAM"]
    pub ramn106: RAMN106,
    #[doc = "0x22c - Embedded RAM"]
    pub ramn107: RAMN107,
    #[doc = "0x230 - Embedded RAM"]
    pub ramn108: RAMN108,
    #[doc = "0x234 - Embedded RAM"]
    pub ramn109: RAMN109,
    #[doc = "0x238 - Embedded RAM"]
    pub ramn110: RAMN110,
    #[doc = "0x23c - Embedded RAM"]
    pub ramn111: RAMN111,
    #[doc = "0x240 - Embedded RAM"]
    pub ramn112: RAMN112,
    #[doc = "0x244 - Embedded RAM"]
    pub ramn113: RAMN113,
    #[doc = "0x248 - Embedded RAM"]
    pub ramn114: RAMN114,
    #[doc = "0x24c - Embedded RAM"]
    pub ramn115: RAMN115,
    #[doc = "0x250 - Embedded RAM"]
    pub ramn116: RAMN116,
    #[doc = "0x254 - Embedded RAM"]
    pub ramn117: RAMN117,
    #[doc = "0x258 - Embedded RAM"]
    pub ramn118: RAMN118,
    #[doc = "0x25c - Embedded RAM"]
    pub ramn119: RAMN119,
    #[doc = "0x260 - Embedded RAM"]
    pub ramn120: RAMN120,
    #[doc = "0x264 - Embedded RAM"]
    pub ramn121: RAMN121,
    #[doc = "0x268 - Embedded RAM"]
    pub ramn122: RAMN122,
    #[doc = "0x26c - Embedded RAM"]
    pub ramn123: RAMN123,
    #[doc = "0x270 - Embedded RAM"]
    pub ramn124: RAMN124,
    #[doc = "0x274 - Embedded RAM"]
    pub ramn125: RAMN125,
    #[doc = "0x278 - Embedded RAM"]
    pub ramn126: RAMN126,
    #[doc = "0x27c - Embedded RAM"]
    pub ramn127: RAMN127,
    _reserved144: [u8; 1536usize],
    #[doc = "0x880 - Rx Individual Mask Registers"]
    pub rximr0: RXIMR0,
    #[doc = "0x884 - Rx Individual Mask Registers"]
    pub rximr1: RXIMR1,
    #[doc = "0x888 - Rx Individual Mask Registers"]
    pub rximr2: RXIMR2,
    #[doc = "0x88c - Rx Individual Mask Registers"]
    pub rximr3: RXIMR3,
    #[doc = "0x890 - Rx Individual Mask Registers"]
    pub rximr4: RXIMR4,
    #[doc = "0x894 - Rx Individual Mask Registers"]
    pub rximr5: RXIMR5,
    #[doc = "0x898 - Rx Individual Mask Registers"]
    pub rximr6: RXIMR6,
    #[doc = "0x89c - Rx Individual Mask Registers"]
    pub rximr7: RXIMR7,
    #[doc = "0x8a0 - Rx Individual Mask Registers"]
    pub rximr8: RXIMR8,
    #[doc = "0x8a4 - Rx Individual Mask Registers"]
    pub rximr9: RXIMR9,
    #[doc = "0x8a8 - Rx Individual Mask Registers"]
    pub rximr10: RXIMR10,
    #[doc = "0x8ac - Rx Individual Mask Registers"]
    pub rximr11: RXIMR11,
    #[doc = "0x8b0 - Rx Individual Mask Registers"]
    pub rximr12: RXIMR12,
    #[doc = "0x8b4 - Rx Individual Mask Registers"]
    pub rximr13: RXIMR13,
    #[doc = "0x8b8 - Rx Individual Mask Registers"]
    pub rximr14: RXIMR14,
    #[doc = "0x8bc - Rx Individual Mask Registers"]
    pub rximr15: RXIMR15,
    #[doc = "0x8c0 - Rx Individual Mask Registers"]
    pub rximr16: RXIMR16,
    #[doc = "0x8c4 - Rx Individual Mask Registers"]
    pub rximr17: RXIMR17,
    #[doc = "0x8c8 - Rx Individual Mask Registers"]
    pub rximr18: RXIMR18,
    #[doc = "0x8cc - Rx Individual Mask Registers"]
    pub rximr19: RXIMR19,
    #[doc = "0x8d0 - Rx Individual Mask Registers"]
    pub rximr20: RXIMR20,
    #[doc = "0x8d4 - Rx Individual Mask Registers"]
    pub rximr21: RXIMR21,
    #[doc = "0x8d8 - Rx Individual Mask Registers"]
    pub rximr22: RXIMR22,
    #[doc = "0x8dc - Rx Individual Mask Registers"]
    pub rximr23: RXIMR23,
    #[doc = "0x8e0 - Rx Individual Mask Registers"]
    pub rximr24: RXIMR24,
    #[doc = "0x8e4 - Rx Individual Mask Registers"]
    pub rximr25: RXIMR25,
    #[doc = "0x8e8 - Rx Individual Mask Registers"]
    pub rximr26: RXIMR26,
    #[doc = "0x8ec - Rx Individual Mask Registers"]
    pub rximr27: RXIMR27,
    #[doc = "0x8f0 - Rx Individual Mask Registers"]
    pub rximr28: RXIMR28,
    #[doc = "0x8f4 - Rx Individual Mask Registers"]
    pub rximr29: RXIMR29,
    #[doc = "0x8f8 - Rx Individual Mask Registers"]
    pub rximr30: RXIMR30,
    #[doc = "0x8fc - Rx Individual Mask Registers"]
    pub rximr31: RXIMR31,
    _reserved176: [u8; 512usize],
    #[doc = "0xb00 - Pretended Networking Control 1 Register"]
    pub ctrl1_pn: CTRL1_PN,
    #[doc = "0xb04 - Pretended Networking Control 2 Register"]
    pub ctrl2_pn: CTRL2_PN,
    #[doc = "0xb08 - Pretended Networking Wake Up Match Register"]
    pub wu_mtc: WU_MTC,
    #[doc = "0xb0c - Pretended Networking ID Filter 1 Register"]
    pub flt_id1: FLT_ID1,
    #[doc = "0xb10 - Pretended Networking DLC Filter Register"]
    pub flt_dlc: FLT_DLC,
    #[doc = "0xb14 - Pretended Networking Payload Low Filter 1 Register"]
    pub pl1_lo: PL1_LO,
    #[doc = "0xb18 - Pretended Networking Payload High Filter 1 Register"]
    pub pl1_hi: PL1_HI,
    #[doc = "0xb1c - Pretended Networking ID Filter 2 Register / ID Mask Register"]
    pub flt_id2_idmask: FLT_ID2_IDMASK,
    #[doc = "0xb20 - Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register"]
    pub pl2_plmask_lo: PL2_PLMASK_LO,
    #[doc = "0xb24 - Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register"]
    pub pl2_plmask_hi: PL2_PLMASK_HI,
    _reserved186: [u8; 24usize],
    #[doc = "0xb40 - Wake Up Message Buffer Register for C/S"]
    pub wmb0_cs: WMB0_CS,
    #[doc = "0xb44 - Wake Up Message Buffer Register for ID"]
    pub wmb0_id: WMB0_ID,
    #[doc = "0xb48 - Wake Up Message Buffer Register for Data 0-3"]
    pub wmb0_d03: WMB0_D03,
    #[doc = "0xb4c - Wake Up Message Buffer Register Data 4-7"]
    pub wmb0_d47: WMB0_D47,
    #[doc = "0xb50 - Wake Up Message Buffer Register for C/S"]
    pub wmb1_cs: WMB1_CS,
    #[doc = "0xb54 - Wake Up Message Buffer Register for ID"]
    pub wmb1_id: WMB1_ID,
    #[doc = "0xb58 - Wake Up Message Buffer Register for Data 0-3"]
    pub wmb1_d03: WMB1_D03,
    #[doc = "0xb5c - Wake Up Message Buffer Register Data 4-7"]
    pub wmb1_d47: WMB1_D47,
    #[doc = "0xb60 - Wake Up Message Buffer Register for C/S"]
    pub wmb2_cs: WMB2_CS,
    #[doc = "0xb64 - Wake Up Message Buffer Register for ID"]
    pub wmb2_id: WMB2_ID,
    #[doc = "0xb68 - Wake Up Message Buffer Register for Data 0-3"]
    pub wmb2_d03: WMB2_D03,
    #[doc = "0xb6c - Wake Up Message Buffer Register Data 4-7"]
    pub wmb2_d47: WMB2_D47,
    #[doc = "0xb70 - Wake Up Message Buffer Register for C/S"]
    pub wmb3_cs: WMB3_CS,
    #[doc = "0xb74 - Wake Up Message Buffer Register for ID"]
    pub wmb3_id: WMB3_ID,
    #[doc = "0xb78 - Wake Up Message Buffer Register for Data 0-3"]
    pub wmb3_d03: WMB3_D03,
    #[doc = "0xb7c - Wake Up Message Buffer Register Data 4-7"]
    pub wmb3_d47: WMB3_D47,
    _reserved202: [u8; 128usize],
    #[doc = "0xc00 - CAN FD Control Register"]
    pub fdctrl: FDCTRL,
    #[doc = "0xc04 - CAN FD Bit Timing Register"]
    pub fdcbt: FDCBT,
    #[doc = "0xc08 - CAN FD CRC Register"]
    pub fdcrc: FDCRC,
}
#[doc = "Module Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [mcr](mcr) module"]
pub type MCR = crate::Reg<u32, _MCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MCR;
#[doc = "`read()` method returns [mcr::R](mcr::R) reader structure"]
impl crate::Readable for MCR {}
#[doc = "`write(|w| ..)` method takes [mcr::W](mcr::W) writer structure"]
impl crate::Writable for MCR {}
#[doc = "Module Configuration Register"]
pub mod mcr;
#[doc = "Control 1 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctrl1](ctrl1) module"]
pub type CTRL1 = crate::Reg<u32, _CTRL1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL1;
#[doc = "`read()` method returns [ctrl1::R](ctrl1::R) reader structure"]
impl crate::Readable for CTRL1 {}
#[doc = "`write(|w| ..)` method takes [ctrl1::W](ctrl1::W) writer structure"]
impl crate::Writable for CTRL1 {}
#[doc = "Control 1 register"]
pub mod ctrl1;
#[doc = "Free Running Timer\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [timer](timer) module"]
pub type TIMER = crate::Reg<u32, _TIMER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TIMER;
#[doc = "`read()` method returns [timer::R](timer::R) reader structure"]
impl crate::Readable for TIMER {}
#[doc = "`write(|w| ..)` method takes [timer::W](timer::W) writer structure"]
impl crate::Writable for TIMER {}
#[doc = "Free Running Timer"]
pub mod timer;
#[doc = "Rx Mailboxes Global Mask Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rxmgmask](rxmgmask) module"]
pub type RXMGMASK = crate::Reg<u32, _RXMGMASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXMGMASK;
#[doc = "`read()` method returns [rxmgmask::R](rxmgmask::R) reader structure"]
impl crate::Readable for RXMGMASK {}
#[doc = "`write(|w| ..)` method takes [rxmgmask::W](rxmgmask::W) writer structure"]
impl crate::Writable for RXMGMASK {}
#[doc = "Rx Mailboxes Global Mask Register"]
pub mod rxmgmask;
#[doc = "Rx 14 Mask register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rx14mask](rx14mask) module"]
pub type RX14MASK = crate::Reg<u32, _RX14MASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RX14MASK;
#[doc = "`read()` method returns [rx14mask::R](rx14mask::R) reader structure"]
impl crate::Readable for RX14MASK {}
#[doc = "`write(|w| ..)` method takes [rx14mask::W](rx14mask::W) writer structure"]
impl crate::Writable for RX14MASK {}
#[doc = "Rx 14 Mask register"]
pub mod rx14mask;
#[doc = "Rx 15 Mask register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rx15mask](rx15mask) module"]
pub type RX15MASK = crate::Reg<u32, _RX15MASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RX15MASK;
#[doc = "`read()` method returns [rx15mask::R](rx15mask::R) reader structure"]
impl crate::Readable for RX15MASK {}
#[doc = "`write(|w| ..)` method takes [rx15mask::W](rx15mask::W) writer structure"]
impl crate::Writable for RX15MASK {}
#[doc = "Rx 15 Mask register"]
pub mod rx15mask;
#[doc = "Error Counter\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ecr](ecr) module"]
pub type ECR = crate::Reg<u32, _ECR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ECR;
#[doc = "`read()` method returns [ecr::R](ecr::R) reader structure"]
impl crate::Readable for ECR {}
#[doc = "`write(|w| ..)` method takes [ecr::W](ecr::W) writer structure"]
impl crate::Writable for ECR {}
#[doc = "Error Counter"]
pub mod ecr;
#[doc = "Error and Status 1 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [esr1](esr1) module"]
pub type ESR1 = crate::Reg<u32, _ESR1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ESR1;
#[doc = "`read()` method returns [esr1::R](esr1::R) reader structure"]
impl crate::Readable for ESR1 {}
#[doc = "`write(|w| ..)` method takes [esr1::W](esr1::W) writer structure"]
impl crate::Writable for ESR1 {}
#[doc = "Error and Status 1 register"]
pub mod esr1;
#[doc = "Interrupt Masks 1 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [imask1](imask1) module"]
pub type IMASK1 = crate::Reg<u32, _IMASK1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IMASK1;
#[doc = "`read()` method returns [imask1::R](imask1::R) reader structure"]
impl crate::Readable for IMASK1 {}
#[doc = "`write(|w| ..)` method takes [imask1::W](imask1::W) writer structure"]
impl crate::Writable for IMASK1 {}
#[doc = "Interrupt Masks 1 register"]
pub mod imask1;
#[doc = "Interrupt Flags 1 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [iflag1](iflag1) module"]
pub type IFLAG1 = crate::Reg<u32, _IFLAG1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IFLAG1;
#[doc = "`read()` method returns [iflag1::R](iflag1::R) reader structure"]
impl crate::Readable for IFLAG1 {}
#[doc = "`write(|w| ..)` method takes [iflag1::W](iflag1::W) writer structure"]
impl crate::Writable for IFLAG1 {}
#[doc = "Interrupt Flags 1 register"]
pub mod iflag1;
#[doc = "Control 2 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctrl2](ctrl2) module"]
pub type CTRL2 = crate::Reg<u32, _CTRL2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL2;
#[doc = "`read()` method returns [ctrl2::R](ctrl2::R) reader structure"]
impl crate::Readable for CTRL2 {}
#[doc = "`write(|w| ..)` method takes [ctrl2::W](ctrl2::W) writer structure"]
impl crate::Writable for CTRL2 {}
#[doc = "Control 2 register"]
pub mod ctrl2;
#[doc = "Error and Status 2 register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [esr2](esr2) module"]
pub type ESR2 = crate::Reg<u32, _ESR2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ESR2;
#[doc = "`read()` method returns [esr2::R](esr2::R) reader structure"]
impl crate::Readable for ESR2 {}
#[doc = "Error and Status 2 register"]
pub mod esr2;
#[doc = "CRC Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [crcr](crcr) module"]
pub type CRCR = crate::Reg<u32, _CRCR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CRCR;
#[doc = "`read()` method returns [crcr::R](crcr::R) reader structure"]
impl crate::Readable for CRCR {}
#[doc = "CRC Register"]
pub mod crcr;
#[doc = "Rx FIFO Global Mask register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rxfgmask](rxfgmask) module"]
pub type RXFGMASK = crate::Reg<u32, _RXFGMASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXFGMASK;
#[doc = "`read()` method returns [rxfgmask::R](rxfgmask::R) reader structure"]
impl crate::Readable for RXFGMASK {}
#[doc = "`write(|w| ..)` method takes [rxfgmask::W](rxfgmask::W) writer structure"]
impl crate::Writable for RXFGMASK {}
#[doc = "Rx FIFO Global Mask register"]
pub mod rxfgmask;
#[doc = "Rx FIFO Information Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rxfir](rxfir) module"]
pub type RXFIR = crate::Reg<u32, _RXFIR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXFIR;
#[doc = "`read()` method returns [rxfir::R](rxfir::R) reader structure"]
impl crate::Readable for RXFIR {}
#[doc = "Rx FIFO Information Register"]
pub mod rxfir;
#[doc = "CAN Bit Timing Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cbt](cbt) module"]
pub type CBT = crate::Reg<u32, _CBT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CBT;
#[doc = "`read()` method returns [cbt::R](cbt::R) reader structure"]
impl crate::Readable for CBT {}
#[doc = "`write(|w| ..)` method takes [cbt::W](cbt::W) writer structure"]
impl crate::Writable for CBT {}
#[doc = "CAN Bit Timing Register"]
pub mod cbt;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn0](ramn0) module"]
pub type RAMN0 = crate::Reg<u32, _RAMN0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN0;
#[doc = "`read()` method returns [ramn0::R](ramn0::R) reader structure"]
impl crate::Readable for RAMN0 {}
#[doc = "`write(|w| ..)` method takes [ramn0::W](ramn0::W) writer structure"]
impl crate::Writable for RAMN0 {}
#[doc = "Embedded RAM"]
pub mod ramn0;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn1](ramn1) module"]
pub type RAMN1 = crate::Reg<u32, _RAMN1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN1;
#[doc = "`read()` method returns [ramn1::R](ramn1::R) reader structure"]
impl crate::Readable for RAMN1 {}
#[doc = "`write(|w| ..)` method takes [ramn1::W](ramn1::W) writer structure"]
impl crate::Writable for RAMN1 {}
#[doc = "Embedded RAM"]
pub mod ramn1;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn2](ramn2) module"]
pub type RAMN2 = crate::Reg<u32, _RAMN2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN2;
#[doc = "`read()` method returns [ramn2::R](ramn2::R) reader structure"]
impl crate::Readable for RAMN2 {}
#[doc = "`write(|w| ..)` method takes [ramn2::W](ramn2::W) writer structure"]
impl crate::Writable for RAMN2 {}
#[doc = "Embedded RAM"]
pub mod ramn2;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn3](ramn3) module"]
pub type RAMN3 = crate::Reg<u32, _RAMN3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN3;
#[doc = "`read()` method returns [ramn3::R](ramn3::R) reader structure"]
impl crate::Readable for RAMN3 {}
#[doc = "`write(|w| ..)` method takes [ramn3::W](ramn3::W) writer structure"]
impl crate::Writable for RAMN3 {}
#[doc = "Embedded RAM"]
pub mod ramn3;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn4](ramn4) module"]
pub type RAMN4 = crate::Reg<u32, _RAMN4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN4;
#[doc = "`read()` method returns [ramn4::R](ramn4::R) reader structure"]
impl crate::Readable for RAMN4 {}
#[doc = "`write(|w| ..)` method takes [ramn4::W](ramn4::W) writer structure"]
impl crate::Writable for RAMN4 {}
#[doc = "Embedded RAM"]
pub mod ramn4;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn5](ramn5) module"]
pub type RAMN5 = crate::Reg<u32, _RAMN5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN5;
#[doc = "`read()` method returns [ramn5::R](ramn5::R) reader structure"]
impl crate::Readable for RAMN5 {}
#[doc = "`write(|w| ..)` method takes [ramn5::W](ramn5::W) writer structure"]
impl crate::Writable for RAMN5 {}
#[doc = "Embedded RAM"]
pub mod ramn5;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn6](ramn6) module"]
pub type RAMN6 = crate::Reg<u32, _RAMN6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN6;
#[doc = "`read()` method returns [ramn6::R](ramn6::R) reader structure"]
impl crate::Readable for RAMN6 {}
#[doc = "`write(|w| ..)` method takes [ramn6::W](ramn6::W) writer structure"]
impl crate::Writable for RAMN6 {}
#[doc = "Embedded RAM"]
pub mod ramn6;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn7](ramn7) module"]
pub type RAMN7 = crate::Reg<u32, _RAMN7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN7;
#[doc = "`read()` method returns [ramn7::R](ramn7::R) reader structure"]
impl crate::Readable for RAMN7 {}
#[doc = "`write(|w| ..)` method takes [ramn7::W](ramn7::W) writer structure"]
impl crate::Writable for RAMN7 {}
#[doc = "Embedded RAM"]
pub mod ramn7;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn8](ramn8) module"]
pub type RAMN8 = crate::Reg<u32, _RAMN8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN8;
#[doc = "`read()` method returns [ramn8::R](ramn8::R) reader structure"]
impl crate::Readable for RAMN8 {}
#[doc = "`write(|w| ..)` method takes [ramn8::W](ramn8::W) writer structure"]
impl crate::Writable for RAMN8 {}
#[doc = "Embedded RAM"]
pub mod ramn8;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn9](ramn9) module"]
pub type RAMN9 = crate::Reg<u32, _RAMN9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN9;
#[doc = "`read()` method returns [ramn9::R](ramn9::R) reader structure"]
impl crate::Readable for RAMN9 {}
#[doc = "`write(|w| ..)` method takes [ramn9::W](ramn9::W) writer structure"]
impl crate::Writable for RAMN9 {}
#[doc = "Embedded RAM"]
pub mod ramn9;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn10](ramn10) module"]
pub type RAMN10 = crate::Reg<u32, _RAMN10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN10;
#[doc = "`read()` method returns [ramn10::R](ramn10::R) reader structure"]
impl crate::Readable for RAMN10 {}
#[doc = "`write(|w| ..)` method takes [ramn10::W](ramn10::W) writer structure"]
impl crate::Writable for RAMN10 {}
#[doc = "Embedded RAM"]
pub mod ramn10;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn11](ramn11) module"]
pub type RAMN11 = crate::Reg<u32, _RAMN11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN11;
#[doc = "`read()` method returns [ramn11::R](ramn11::R) reader structure"]
impl crate::Readable for RAMN11 {}
#[doc = "`write(|w| ..)` method takes [ramn11::W](ramn11::W) writer structure"]
impl crate::Writable for RAMN11 {}
#[doc = "Embedded RAM"]
pub mod ramn11;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn12](ramn12) module"]
pub type RAMN12 = crate::Reg<u32, _RAMN12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN12;
#[doc = "`read()` method returns [ramn12::R](ramn12::R) reader structure"]
impl crate::Readable for RAMN12 {}
#[doc = "`write(|w| ..)` method takes [ramn12::W](ramn12::W) writer structure"]
impl crate::Writable for RAMN12 {}
#[doc = "Embedded RAM"]
pub mod ramn12;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn13](ramn13) module"]
pub type RAMN13 = crate::Reg<u32, _RAMN13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN13;
#[doc = "`read()` method returns [ramn13::R](ramn13::R) reader structure"]
impl crate::Readable for RAMN13 {}
#[doc = "`write(|w| ..)` method takes [ramn13::W](ramn13::W) writer structure"]
impl crate::Writable for RAMN13 {}
#[doc = "Embedded RAM"]
pub mod ramn13;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn14](ramn14) module"]
pub type RAMN14 = crate::Reg<u32, _RAMN14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN14;
#[doc = "`read()` method returns [ramn14::R](ramn14::R) reader structure"]
impl crate::Readable for RAMN14 {}
#[doc = "`write(|w| ..)` method takes [ramn14::W](ramn14::W) writer structure"]
impl crate::Writable for RAMN14 {}
#[doc = "Embedded RAM"]
pub mod ramn14;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn15](ramn15) module"]
pub type RAMN15 = crate::Reg<u32, _RAMN15>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN15;
#[doc = "`read()` method returns [ramn15::R](ramn15::R) reader structure"]
impl crate::Readable for RAMN15 {}
#[doc = "`write(|w| ..)` method takes [ramn15::W](ramn15::W) writer structure"]
impl crate::Writable for RAMN15 {}
#[doc = "Embedded RAM"]
pub mod ramn15;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn16](ramn16) module"]
pub type RAMN16 = crate::Reg<u32, _RAMN16>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN16;
#[doc = "`read()` method returns [ramn16::R](ramn16::R) reader structure"]
impl crate::Readable for RAMN16 {}
#[doc = "`write(|w| ..)` method takes [ramn16::W](ramn16::W) writer structure"]
impl crate::Writable for RAMN16 {}
#[doc = "Embedded RAM"]
pub mod ramn16;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn17](ramn17) module"]
pub type RAMN17 = crate::Reg<u32, _RAMN17>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN17;
#[doc = "`read()` method returns [ramn17::R](ramn17::R) reader structure"]
impl crate::Readable for RAMN17 {}
#[doc = "`write(|w| ..)` method takes [ramn17::W](ramn17::W) writer structure"]
impl crate::Writable for RAMN17 {}
#[doc = "Embedded RAM"]
pub mod ramn17;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn18](ramn18) module"]
pub type RAMN18 = crate::Reg<u32, _RAMN18>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN18;
#[doc = "`read()` method returns [ramn18::R](ramn18::R) reader structure"]
impl crate::Readable for RAMN18 {}
#[doc = "`write(|w| ..)` method takes [ramn18::W](ramn18::W) writer structure"]
impl crate::Writable for RAMN18 {}
#[doc = "Embedded RAM"]
pub mod ramn18;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn19](ramn19) module"]
pub type RAMN19 = crate::Reg<u32, _RAMN19>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN19;
#[doc = "`read()` method returns [ramn19::R](ramn19::R) reader structure"]
impl crate::Readable for RAMN19 {}
#[doc = "`write(|w| ..)` method takes [ramn19::W](ramn19::W) writer structure"]
impl crate::Writable for RAMN19 {}
#[doc = "Embedded RAM"]
pub mod ramn19;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn20](ramn20) module"]
pub type RAMN20 = crate::Reg<u32, _RAMN20>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN20;
#[doc = "`read()` method returns [ramn20::R](ramn20::R) reader structure"]
impl crate::Readable for RAMN20 {}
#[doc = "`write(|w| ..)` method takes [ramn20::W](ramn20::W) writer structure"]
impl crate::Writable for RAMN20 {}
#[doc = "Embedded RAM"]
pub mod ramn20;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn21](ramn21) module"]
pub type RAMN21 = crate::Reg<u32, _RAMN21>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN21;
#[doc = "`read()` method returns [ramn21::R](ramn21::R) reader structure"]
impl crate::Readable for RAMN21 {}
#[doc = "`write(|w| ..)` method takes [ramn21::W](ramn21::W) writer structure"]
impl crate::Writable for RAMN21 {}
#[doc = "Embedded RAM"]
pub mod ramn21;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn22](ramn22) module"]
pub type RAMN22 = crate::Reg<u32, _RAMN22>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN22;
#[doc = "`read()` method returns [ramn22::R](ramn22::R) reader structure"]
impl crate::Readable for RAMN22 {}
#[doc = "`write(|w| ..)` method takes [ramn22::W](ramn22::W) writer structure"]
impl crate::Writable for RAMN22 {}
#[doc = "Embedded RAM"]
pub mod ramn22;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn23](ramn23) module"]
pub type RAMN23 = crate::Reg<u32, _RAMN23>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN23;
#[doc = "`read()` method returns [ramn23::R](ramn23::R) reader structure"]
impl crate::Readable for RAMN23 {}
#[doc = "`write(|w| ..)` method takes [ramn23::W](ramn23::W) writer structure"]
impl crate::Writable for RAMN23 {}
#[doc = "Embedded RAM"]
pub mod ramn23;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn24](ramn24) module"]
pub type RAMN24 = crate::Reg<u32, _RAMN24>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN24;
#[doc = "`read()` method returns [ramn24::R](ramn24::R) reader structure"]
impl crate::Readable for RAMN24 {}
#[doc = "`write(|w| ..)` method takes [ramn24::W](ramn24::W) writer structure"]
impl crate::Writable for RAMN24 {}
#[doc = "Embedded RAM"]
pub mod ramn24;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn25](ramn25) module"]
pub type RAMN25 = crate::Reg<u32, _RAMN25>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN25;
#[doc = "`read()` method returns [ramn25::R](ramn25::R) reader structure"]
impl crate::Readable for RAMN25 {}
#[doc = "`write(|w| ..)` method takes [ramn25::W](ramn25::W) writer structure"]
impl crate::Writable for RAMN25 {}
#[doc = "Embedded RAM"]
pub mod ramn25;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn26](ramn26) module"]
pub type RAMN26 = crate::Reg<u32, _RAMN26>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN26;
#[doc = "`read()` method returns [ramn26::R](ramn26::R) reader structure"]
impl crate::Readable for RAMN26 {}
#[doc = "`write(|w| ..)` method takes [ramn26::W](ramn26::W) writer structure"]
impl crate::Writable for RAMN26 {}
#[doc = "Embedded RAM"]
pub mod ramn26;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn27](ramn27) module"]
pub type RAMN27 = crate::Reg<u32, _RAMN27>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN27;
#[doc = "`read()` method returns [ramn27::R](ramn27::R) reader structure"]
impl crate::Readable for RAMN27 {}
#[doc = "`write(|w| ..)` method takes [ramn27::W](ramn27::W) writer structure"]
impl crate::Writable for RAMN27 {}
#[doc = "Embedded RAM"]
pub mod ramn27;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn28](ramn28) module"]
pub type RAMN28 = crate::Reg<u32, _RAMN28>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN28;
#[doc = "`read()` method returns [ramn28::R](ramn28::R) reader structure"]
impl crate::Readable for RAMN28 {}
#[doc = "`write(|w| ..)` method takes [ramn28::W](ramn28::W) writer structure"]
impl crate::Writable for RAMN28 {}
#[doc = "Embedded RAM"]
pub mod ramn28;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn29](ramn29) module"]
pub type RAMN29 = crate::Reg<u32, _RAMN29>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN29;
#[doc = "`read()` method returns [ramn29::R](ramn29::R) reader structure"]
impl crate::Readable for RAMN29 {}
#[doc = "`write(|w| ..)` method takes [ramn29::W](ramn29::W) writer structure"]
impl crate::Writable for RAMN29 {}
#[doc = "Embedded RAM"]
pub mod ramn29;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn30](ramn30) module"]
pub type RAMN30 = crate::Reg<u32, _RAMN30>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN30;
#[doc = "`read()` method returns [ramn30::R](ramn30::R) reader structure"]
impl crate::Readable for RAMN30 {}
#[doc = "`write(|w| ..)` method takes [ramn30::W](ramn30::W) writer structure"]
impl crate::Writable for RAMN30 {}
#[doc = "Embedded RAM"]
pub mod ramn30;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn31](ramn31) module"]
pub type RAMN31 = crate::Reg<u32, _RAMN31>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN31;
#[doc = "`read()` method returns [ramn31::R](ramn31::R) reader structure"]
impl crate::Readable for RAMN31 {}
#[doc = "`write(|w| ..)` method takes [ramn31::W](ramn31::W) writer structure"]
impl crate::Writable for RAMN31 {}
#[doc = "Embedded RAM"]
pub mod ramn31;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn32](ramn32) module"]
pub type RAMN32 = crate::Reg<u32, _RAMN32>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN32;
#[doc = "`read()` method returns [ramn32::R](ramn32::R) reader structure"]
impl crate::Readable for RAMN32 {}
#[doc = "`write(|w| ..)` method takes [ramn32::W](ramn32::W) writer structure"]
impl crate::Writable for RAMN32 {}
#[doc = "Embedded RAM"]
pub mod ramn32;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn33](ramn33) module"]
pub type RAMN33 = crate::Reg<u32, _RAMN33>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN33;
#[doc = "`read()` method returns [ramn33::R](ramn33::R) reader structure"]
impl crate::Readable for RAMN33 {}
#[doc = "`write(|w| ..)` method takes [ramn33::W](ramn33::W) writer structure"]
impl crate::Writable for RAMN33 {}
#[doc = "Embedded RAM"]
pub mod ramn33;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn34](ramn34) module"]
pub type RAMN34 = crate::Reg<u32, _RAMN34>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN34;
#[doc = "`read()` method returns [ramn34::R](ramn34::R) reader structure"]
impl crate::Readable for RAMN34 {}
#[doc = "`write(|w| ..)` method takes [ramn34::W](ramn34::W) writer structure"]
impl crate::Writable for RAMN34 {}
#[doc = "Embedded RAM"]
pub mod ramn34;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn35](ramn35) module"]
pub type RAMN35 = crate::Reg<u32, _RAMN35>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN35;
#[doc = "`read()` method returns [ramn35::R](ramn35::R) reader structure"]
impl crate::Readable for RAMN35 {}
#[doc = "`write(|w| ..)` method takes [ramn35::W](ramn35::W) writer structure"]
impl crate::Writable for RAMN35 {}
#[doc = "Embedded RAM"]
pub mod ramn35;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn36](ramn36) module"]
pub type RAMN36 = crate::Reg<u32, _RAMN36>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN36;
#[doc = "`read()` method returns [ramn36::R](ramn36::R) reader structure"]
impl crate::Readable for RAMN36 {}
#[doc = "`write(|w| ..)` method takes [ramn36::W](ramn36::W) writer structure"]
impl crate::Writable for RAMN36 {}
#[doc = "Embedded RAM"]
pub mod ramn36;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn37](ramn37) module"]
pub type RAMN37 = crate::Reg<u32, _RAMN37>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN37;
#[doc = "`read()` method returns [ramn37::R](ramn37::R) reader structure"]
impl crate::Readable for RAMN37 {}
#[doc = "`write(|w| ..)` method takes [ramn37::W](ramn37::W) writer structure"]
impl crate::Writable for RAMN37 {}
#[doc = "Embedded RAM"]
pub mod ramn37;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn38](ramn38) module"]
pub type RAMN38 = crate::Reg<u32, _RAMN38>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN38;
#[doc = "`read()` method returns [ramn38::R](ramn38::R) reader structure"]
impl crate::Readable for RAMN38 {}
#[doc = "`write(|w| ..)` method takes [ramn38::W](ramn38::W) writer structure"]
impl crate::Writable for RAMN38 {}
#[doc = "Embedded RAM"]
pub mod ramn38;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn39](ramn39) module"]
pub type RAMN39 = crate::Reg<u32, _RAMN39>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN39;
#[doc = "`read()` method returns [ramn39::R](ramn39::R) reader structure"]
impl crate::Readable for RAMN39 {}
#[doc = "`write(|w| ..)` method takes [ramn39::W](ramn39::W) writer structure"]
impl crate::Writable for RAMN39 {}
#[doc = "Embedded RAM"]
pub mod ramn39;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn40](ramn40) module"]
pub type RAMN40 = crate::Reg<u32, _RAMN40>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN40;
#[doc = "`read()` method returns [ramn40::R](ramn40::R) reader structure"]
impl crate::Readable for RAMN40 {}
#[doc = "`write(|w| ..)` method takes [ramn40::W](ramn40::W) writer structure"]
impl crate::Writable for RAMN40 {}
#[doc = "Embedded RAM"]
pub mod ramn40;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn41](ramn41) module"]
pub type RAMN41 = crate::Reg<u32, _RAMN41>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN41;
#[doc = "`read()` method returns [ramn41::R](ramn41::R) reader structure"]
impl crate::Readable for RAMN41 {}
#[doc = "`write(|w| ..)` method takes [ramn41::W](ramn41::W) writer structure"]
impl crate::Writable for RAMN41 {}
#[doc = "Embedded RAM"]
pub mod ramn41;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn42](ramn42) module"]
pub type RAMN42 = crate::Reg<u32, _RAMN42>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN42;
#[doc = "`read()` method returns [ramn42::R](ramn42::R) reader structure"]
impl crate::Readable for RAMN42 {}
#[doc = "`write(|w| ..)` method takes [ramn42::W](ramn42::W) writer structure"]
impl crate::Writable for RAMN42 {}
#[doc = "Embedded RAM"]
pub mod ramn42;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn43](ramn43) module"]
pub type RAMN43 = crate::Reg<u32, _RAMN43>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN43;
#[doc = "`read()` method returns [ramn43::R](ramn43::R) reader structure"]
impl crate::Readable for RAMN43 {}
#[doc = "`write(|w| ..)` method takes [ramn43::W](ramn43::W) writer structure"]
impl crate::Writable for RAMN43 {}
#[doc = "Embedded RAM"]
pub mod ramn43;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn44](ramn44) module"]
pub type RAMN44 = crate::Reg<u32, _RAMN44>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN44;
#[doc = "`read()` method returns [ramn44::R](ramn44::R) reader structure"]
impl crate::Readable for RAMN44 {}
#[doc = "`write(|w| ..)` method takes [ramn44::W](ramn44::W) writer structure"]
impl crate::Writable for RAMN44 {}
#[doc = "Embedded RAM"]
pub mod ramn44;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn45](ramn45) module"]
pub type RAMN45 = crate::Reg<u32, _RAMN45>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN45;
#[doc = "`read()` method returns [ramn45::R](ramn45::R) reader structure"]
impl crate::Readable for RAMN45 {}
#[doc = "`write(|w| ..)` method takes [ramn45::W](ramn45::W) writer structure"]
impl crate::Writable for RAMN45 {}
#[doc = "Embedded RAM"]
pub mod ramn45;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn46](ramn46) module"]
pub type RAMN46 = crate::Reg<u32, _RAMN46>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN46;
#[doc = "`read()` method returns [ramn46::R](ramn46::R) reader structure"]
impl crate::Readable for RAMN46 {}
#[doc = "`write(|w| ..)` method takes [ramn46::W](ramn46::W) writer structure"]
impl crate::Writable for RAMN46 {}
#[doc = "Embedded RAM"]
pub mod ramn46;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn47](ramn47) module"]
pub type RAMN47 = crate::Reg<u32, _RAMN47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN47;
#[doc = "`read()` method returns [ramn47::R](ramn47::R) reader structure"]
impl crate::Readable for RAMN47 {}
#[doc = "`write(|w| ..)` method takes [ramn47::W](ramn47::W) writer structure"]
impl crate::Writable for RAMN47 {}
#[doc = "Embedded RAM"]
pub mod ramn47;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn48](ramn48) module"]
pub type RAMN48 = crate::Reg<u32, _RAMN48>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN48;
#[doc = "`read()` method returns [ramn48::R](ramn48::R) reader structure"]
impl crate::Readable for RAMN48 {}
#[doc = "`write(|w| ..)` method takes [ramn48::W](ramn48::W) writer structure"]
impl crate::Writable for RAMN48 {}
#[doc = "Embedded RAM"]
pub mod ramn48;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn49](ramn49) module"]
pub type RAMN49 = crate::Reg<u32, _RAMN49>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN49;
#[doc = "`read()` method returns [ramn49::R](ramn49::R) reader structure"]
impl crate::Readable for RAMN49 {}
#[doc = "`write(|w| ..)` method takes [ramn49::W](ramn49::W) writer structure"]
impl crate::Writable for RAMN49 {}
#[doc = "Embedded RAM"]
pub mod ramn49;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn50](ramn50) module"]
pub type RAMN50 = crate::Reg<u32, _RAMN50>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN50;
#[doc = "`read()` method returns [ramn50::R](ramn50::R) reader structure"]
impl crate::Readable for RAMN50 {}
#[doc = "`write(|w| ..)` method takes [ramn50::W](ramn50::W) writer structure"]
impl crate::Writable for RAMN50 {}
#[doc = "Embedded RAM"]
pub mod ramn50;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn51](ramn51) module"]
pub type RAMN51 = crate::Reg<u32, _RAMN51>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN51;
#[doc = "`read()` method returns [ramn51::R](ramn51::R) reader structure"]
impl crate::Readable for RAMN51 {}
#[doc = "`write(|w| ..)` method takes [ramn51::W](ramn51::W) writer structure"]
impl crate::Writable for RAMN51 {}
#[doc = "Embedded RAM"]
pub mod ramn51;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn52](ramn52) module"]
pub type RAMN52 = crate::Reg<u32, _RAMN52>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN52;
#[doc = "`read()` method returns [ramn52::R](ramn52::R) reader structure"]
impl crate::Readable for RAMN52 {}
#[doc = "`write(|w| ..)` method takes [ramn52::W](ramn52::W) writer structure"]
impl crate::Writable for RAMN52 {}
#[doc = "Embedded RAM"]
pub mod ramn52;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn53](ramn53) module"]
pub type RAMN53 = crate::Reg<u32, _RAMN53>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN53;
#[doc = "`read()` method returns [ramn53::R](ramn53::R) reader structure"]
impl crate::Readable for RAMN53 {}
#[doc = "`write(|w| ..)` method takes [ramn53::W](ramn53::W) writer structure"]
impl crate::Writable for RAMN53 {}
#[doc = "Embedded RAM"]
pub mod ramn53;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn54](ramn54) module"]
pub type RAMN54 = crate::Reg<u32, _RAMN54>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN54;
#[doc = "`read()` method returns [ramn54::R](ramn54::R) reader structure"]
impl crate::Readable for RAMN54 {}
#[doc = "`write(|w| ..)` method takes [ramn54::W](ramn54::W) writer structure"]
impl crate::Writable for RAMN54 {}
#[doc = "Embedded RAM"]
pub mod ramn54;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn55](ramn55) module"]
pub type RAMN55 = crate::Reg<u32, _RAMN55>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN55;
#[doc = "`read()` method returns [ramn55::R](ramn55::R) reader structure"]
impl crate::Readable for RAMN55 {}
#[doc = "`write(|w| ..)` method takes [ramn55::W](ramn55::W) writer structure"]
impl crate::Writable for RAMN55 {}
#[doc = "Embedded RAM"]
pub mod ramn55;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn56](ramn56) module"]
pub type RAMN56 = crate::Reg<u32, _RAMN56>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN56;
#[doc = "`read()` method returns [ramn56::R](ramn56::R) reader structure"]
impl crate::Readable for RAMN56 {}
#[doc = "`write(|w| ..)` method takes [ramn56::W](ramn56::W) writer structure"]
impl crate::Writable for RAMN56 {}
#[doc = "Embedded RAM"]
pub mod ramn56;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn57](ramn57) module"]
pub type RAMN57 = crate::Reg<u32, _RAMN57>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN57;
#[doc = "`read()` method returns [ramn57::R](ramn57::R) reader structure"]
impl crate::Readable for RAMN57 {}
#[doc = "`write(|w| ..)` method takes [ramn57::W](ramn57::W) writer structure"]
impl crate::Writable for RAMN57 {}
#[doc = "Embedded RAM"]
pub mod ramn57;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn58](ramn58) module"]
pub type RAMN58 = crate::Reg<u32, _RAMN58>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN58;
#[doc = "`read()` method returns [ramn58::R](ramn58::R) reader structure"]
impl crate::Readable for RAMN58 {}
#[doc = "`write(|w| ..)` method takes [ramn58::W](ramn58::W) writer structure"]
impl crate::Writable for RAMN58 {}
#[doc = "Embedded RAM"]
pub mod ramn58;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn59](ramn59) module"]
pub type RAMN59 = crate::Reg<u32, _RAMN59>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN59;
#[doc = "`read()` method returns [ramn59::R](ramn59::R) reader structure"]
impl crate::Readable for RAMN59 {}
#[doc = "`write(|w| ..)` method takes [ramn59::W](ramn59::W) writer structure"]
impl crate::Writable for RAMN59 {}
#[doc = "Embedded RAM"]
pub mod ramn59;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn60](ramn60) module"]
pub type RAMN60 = crate::Reg<u32, _RAMN60>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN60;
#[doc = "`read()` method returns [ramn60::R](ramn60::R) reader structure"]
impl crate::Readable for RAMN60 {}
#[doc = "`write(|w| ..)` method takes [ramn60::W](ramn60::W) writer structure"]
impl crate::Writable for RAMN60 {}
#[doc = "Embedded RAM"]
pub mod ramn60;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn61](ramn61) module"]
pub type RAMN61 = crate::Reg<u32, _RAMN61>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN61;
#[doc = "`read()` method returns [ramn61::R](ramn61::R) reader structure"]
impl crate::Readable for RAMN61 {}
#[doc = "`write(|w| ..)` method takes [ramn61::W](ramn61::W) writer structure"]
impl crate::Writable for RAMN61 {}
#[doc = "Embedded RAM"]
pub mod ramn61;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn62](ramn62) module"]
pub type RAMN62 = crate::Reg<u32, _RAMN62>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN62;
#[doc = "`read()` method returns [ramn62::R](ramn62::R) reader structure"]
impl crate::Readable for RAMN62 {}
#[doc = "`write(|w| ..)` method takes [ramn62::W](ramn62::W) writer structure"]
impl crate::Writable for RAMN62 {}
#[doc = "Embedded RAM"]
pub mod ramn62;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn63](ramn63) module"]
pub type RAMN63 = crate::Reg<u32, _RAMN63>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN63;
#[doc = "`read()` method returns [ramn63::R](ramn63::R) reader structure"]
impl crate::Readable for RAMN63 {}
#[doc = "`write(|w| ..)` method takes [ramn63::W](ramn63::W) writer structure"]
impl crate::Writable for RAMN63 {}
#[doc = "Embedded RAM"]
pub mod ramn63;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn64](ramn64) module"]
pub type RAMN64 = crate::Reg<u32, _RAMN64>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN64;
#[doc = "`read()` method returns [ramn64::R](ramn64::R) reader structure"]
impl crate::Readable for RAMN64 {}
#[doc = "`write(|w| ..)` method takes [ramn64::W](ramn64::W) writer structure"]
impl crate::Writable for RAMN64 {}
#[doc = "Embedded RAM"]
pub mod ramn64;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn65](ramn65) module"]
pub type RAMN65 = crate::Reg<u32, _RAMN65>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN65;
#[doc = "`read()` method returns [ramn65::R](ramn65::R) reader structure"]
impl crate::Readable for RAMN65 {}
#[doc = "`write(|w| ..)` method takes [ramn65::W](ramn65::W) writer structure"]
impl crate::Writable for RAMN65 {}
#[doc = "Embedded RAM"]
pub mod ramn65;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn66](ramn66) module"]
pub type RAMN66 = crate::Reg<u32, _RAMN66>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN66;
#[doc = "`read()` method returns [ramn66::R](ramn66::R) reader structure"]
impl crate::Readable for RAMN66 {}
#[doc = "`write(|w| ..)` method takes [ramn66::W](ramn66::W) writer structure"]
impl crate::Writable for RAMN66 {}
#[doc = "Embedded RAM"]
pub mod ramn66;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn67](ramn67) module"]
pub type RAMN67 = crate::Reg<u32, _RAMN67>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN67;
#[doc = "`read()` method returns [ramn67::R](ramn67::R) reader structure"]
impl crate::Readable for RAMN67 {}
#[doc = "`write(|w| ..)` method takes [ramn67::W](ramn67::W) writer structure"]
impl crate::Writable for RAMN67 {}
#[doc = "Embedded RAM"]
pub mod ramn67;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn68](ramn68) module"]
pub type RAMN68 = crate::Reg<u32, _RAMN68>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN68;
#[doc = "`read()` method returns [ramn68::R](ramn68::R) reader structure"]
impl crate::Readable for RAMN68 {}
#[doc = "`write(|w| ..)` method takes [ramn68::W](ramn68::W) writer structure"]
impl crate::Writable for RAMN68 {}
#[doc = "Embedded RAM"]
pub mod ramn68;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn69](ramn69) module"]
pub type RAMN69 = crate::Reg<u32, _RAMN69>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN69;
#[doc = "`read()` method returns [ramn69::R](ramn69::R) reader structure"]
impl crate::Readable for RAMN69 {}
#[doc = "`write(|w| ..)` method takes [ramn69::W](ramn69::W) writer structure"]
impl crate::Writable for RAMN69 {}
#[doc = "Embedded RAM"]
pub mod ramn69;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn70](ramn70) module"]
pub type RAMN70 = crate::Reg<u32, _RAMN70>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN70;
#[doc = "`read()` method returns [ramn70::R](ramn70::R) reader structure"]
impl crate::Readable for RAMN70 {}
#[doc = "`write(|w| ..)` method takes [ramn70::W](ramn70::W) writer structure"]
impl crate::Writable for RAMN70 {}
#[doc = "Embedded RAM"]
pub mod ramn70;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn71](ramn71) module"]
pub type RAMN71 = crate::Reg<u32, _RAMN71>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN71;
#[doc = "`read()` method returns [ramn71::R](ramn71::R) reader structure"]
impl crate::Readable for RAMN71 {}
#[doc = "`write(|w| ..)` method takes [ramn71::W](ramn71::W) writer structure"]
impl crate::Writable for RAMN71 {}
#[doc = "Embedded RAM"]
pub mod ramn71;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn72](ramn72) module"]
pub type RAMN72 = crate::Reg<u32, _RAMN72>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN72;
#[doc = "`read()` method returns [ramn72::R](ramn72::R) reader structure"]
impl crate::Readable for RAMN72 {}
#[doc = "`write(|w| ..)` method takes [ramn72::W](ramn72::W) writer structure"]
impl crate::Writable for RAMN72 {}
#[doc = "Embedded RAM"]
pub mod ramn72;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn73](ramn73) module"]
pub type RAMN73 = crate::Reg<u32, _RAMN73>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN73;
#[doc = "`read()` method returns [ramn73::R](ramn73::R) reader structure"]
impl crate::Readable for RAMN73 {}
#[doc = "`write(|w| ..)` method takes [ramn73::W](ramn73::W) writer structure"]
impl crate::Writable for RAMN73 {}
#[doc = "Embedded RAM"]
pub mod ramn73;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn74](ramn74) module"]
pub type RAMN74 = crate::Reg<u32, _RAMN74>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN74;
#[doc = "`read()` method returns [ramn74::R](ramn74::R) reader structure"]
impl crate::Readable for RAMN74 {}
#[doc = "`write(|w| ..)` method takes [ramn74::W](ramn74::W) writer structure"]
impl crate::Writable for RAMN74 {}
#[doc = "Embedded RAM"]
pub mod ramn74;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn75](ramn75) module"]
pub type RAMN75 = crate::Reg<u32, _RAMN75>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN75;
#[doc = "`read()` method returns [ramn75::R](ramn75::R) reader structure"]
impl crate::Readable for RAMN75 {}
#[doc = "`write(|w| ..)` method takes [ramn75::W](ramn75::W) writer structure"]
impl crate::Writable for RAMN75 {}
#[doc = "Embedded RAM"]
pub mod ramn75;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn76](ramn76) module"]
pub type RAMN76 = crate::Reg<u32, _RAMN76>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN76;
#[doc = "`read()` method returns [ramn76::R](ramn76::R) reader structure"]
impl crate::Readable for RAMN76 {}
#[doc = "`write(|w| ..)` method takes [ramn76::W](ramn76::W) writer structure"]
impl crate::Writable for RAMN76 {}
#[doc = "Embedded RAM"]
pub mod ramn76;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn77](ramn77) module"]
pub type RAMN77 = crate::Reg<u32, _RAMN77>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN77;
#[doc = "`read()` method returns [ramn77::R](ramn77::R) reader structure"]
impl crate::Readable for RAMN77 {}
#[doc = "`write(|w| ..)` method takes [ramn77::W](ramn77::W) writer structure"]
impl crate::Writable for RAMN77 {}
#[doc = "Embedded RAM"]
pub mod ramn77;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn78](ramn78) module"]
pub type RAMN78 = crate::Reg<u32, _RAMN78>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN78;
#[doc = "`read()` method returns [ramn78::R](ramn78::R) reader structure"]
impl crate::Readable for RAMN78 {}
#[doc = "`write(|w| ..)` method takes [ramn78::W](ramn78::W) writer structure"]
impl crate::Writable for RAMN78 {}
#[doc = "Embedded RAM"]
pub mod ramn78;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn79](ramn79) module"]
pub type RAMN79 = crate::Reg<u32, _RAMN79>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN79;
#[doc = "`read()` method returns [ramn79::R](ramn79::R) reader structure"]
impl crate::Readable for RAMN79 {}
#[doc = "`write(|w| ..)` method takes [ramn79::W](ramn79::W) writer structure"]
impl crate::Writable for RAMN79 {}
#[doc = "Embedded RAM"]
pub mod ramn79;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn80](ramn80) module"]
pub type RAMN80 = crate::Reg<u32, _RAMN80>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN80;
#[doc = "`read()` method returns [ramn80::R](ramn80::R) reader structure"]
impl crate::Readable for RAMN80 {}
#[doc = "`write(|w| ..)` method takes [ramn80::W](ramn80::W) writer structure"]
impl crate::Writable for RAMN80 {}
#[doc = "Embedded RAM"]
pub mod ramn80;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn81](ramn81) module"]
pub type RAMN81 = crate::Reg<u32, _RAMN81>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN81;
#[doc = "`read()` method returns [ramn81::R](ramn81::R) reader structure"]
impl crate::Readable for RAMN81 {}
#[doc = "`write(|w| ..)` method takes [ramn81::W](ramn81::W) writer structure"]
impl crate::Writable for RAMN81 {}
#[doc = "Embedded RAM"]
pub mod ramn81;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn82](ramn82) module"]
pub type RAMN82 = crate::Reg<u32, _RAMN82>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN82;
#[doc = "`read()` method returns [ramn82::R](ramn82::R) reader structure"]
impl crate::Readable for RAMN82 {}
#[doc = "`write(|w| ..)` method takes [ramn82::W](ramn82::W) writer structure"]
impl crate::Writable for RAMN82 {}
#[doc = "Embedded RAM"]
pub mod ramn82;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn83](ramn83) module"]
pub type RAMN83 = crate::Reg<u32, _RAMN83>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN83;
#[doc = "`read()` method returns [ramn83::R](ramn83::R) reader structure"]
impl crate::Readable for RAMN83 {}
#[doc = "`write(|w| ..)` method takes [ramn83::W](ramn83::W) writer structure"]
impl crate::Writable for RAMN83 {}
#[doc = "Embedded RAM"]
pub mod ramn83;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn84](ramn84) module"]
pub type RAMN84 = crate::Reg<u32, _RAMN84>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN84;
#[doc = "`read()` method returns [ramn84::R](ramn84::R) reader structure"]
impl crate::Readable for RAMN84 {}
#[doc = "`write(|w| ..)` method takes [ramn84::W](ramn84::W) writer structure"]
impl crate::Writable for RAMN84 {}
#[doc = "Embedded RAM"]
pub mod ramn84;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn85](ramn85) module"]
pub type RAMN85 = crate::Reg<u32, _RAMN85>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN85;
#[doc = "`read()` method returns [ramn85::R](ramn85::R) reader structure"]
impl crate::Readable for RAMN85 {}
#[doc = "`write(|w| ..)` method takes [ramn85::W](ramn85::W) writer structure"]
impl crate::Writable for RAMN85 {}
#[doc = "Embedded RAM"]
pub mod ramn85;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn86](ramn86) module"]
pub type RAMN86 = crate::Reg<u32, _RAMN86>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN86;
#[doc = "`read()` method returns [ramn86::R](ramn86::R) reader structure"]
impl crate::Readable for RAMN86 {}
#[doc = "`write(|w| ..)` method takes [ramn86::W](ramn86::W) writer structure"]
impl crate::Writable for RAMN86 {}
#[doc = "Embedded RAM"]
pub mod ramn86;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn87](ramn87) module"]
pub type RAMN87 = crate::Reg<u32, _RAMN87>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN87;
#[doc = "`read()` method returns [ramn87::R](ramn87::R) reader structure"]
impl crate::Readable for RAMN87 {}
#[doc = "`write(|w| ..)` method takes [ramn87::W](ramn87::W) writer structure"]
impl crate::Writable for RAMN87 {}
#[doc = "Embedded RAM"]
pub mod ramn87;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn88](ramn88) module"]
pub type RAMN88 = crate::Reg<u32, _RAMN88>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN88;
#[doc = "`read()` method returns [ramn88::R](ramn88::R) reader structure"]
impl crate::Readable for RAMN88 {}
#[doc = "`write(|w| ..)` method takes [ramn88::W](ramn88::W) writer structure"]
impl crate::Writable for RAMN88 {}
#[doc = "Embedded RAM"]
pub mod ramn88;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn89](ramn89) module"]
pub type RAMN89 = crate::Reg<u32, _RAMN89>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN89;
#[doc = "`read()` method returns [ramn89::R](ramn89::R) reader structure"]
impl crate::Readable for RAMN89 {}
#[doc = "`write(|w| ..)` method takes [ramn89::W](ramn89::W) writer structure"]
impl crate::Writable for RAMN89 {}
#[doc = "Embedded RAM"]
pub mod ramn89;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn90](ramn90) module"]
pub type RAMN90 = crate::Reg<u32, _RAMN90>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN90;
#[doc = "`read()` method returns [ramn90::R](ramn90::R) reader structure"]
impl crate::Readable for RAMN90 {}
#[doc = "`write(|w| ..)` method takes [ramn90::W](ramn90::W) writer structure"]
impl crate::Writable for RAMN90 {}
#[doc = "Embedded RAM"]
pub mod ramn90;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn91](ramn91) module"]
pub type RAMN91 = crate::Reg<u32, _RAMN91>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN91;
#[doc = "`read()` method returns [ramn91::R](ramn91::R) reader structure"]
impl crate::Readable for RAMN91 {}
#[doc = "`write(|w| ..)` method takes [ramn91::W](ramn91::W) writer structure"]
impl crate::Writable for RAMN91 {}
#[doc = "Embedded RAM"]
pub mod ramn91;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn92](ramn92) module"]
pub type RAMN92 = crate::Reg<u32, _RAMN92>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN92;
#[doc = "`read()` method returns [ramn92::R](ramn92::R) reader structure"]
impl crate::Readable for RAMN92 {}
#[doc = "`write(|w| ..)` method takes [ramn92::W](ramn92::W) writer structure"]
impl crate::Writable for RAMN92 {}
#[doc = "Embedded RAM"]
pub mod ramn92;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn93](ramn93) module"]
pub type RAMN93 = crate::Reg<u32, _RAMN93>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN93;
#[doc = "`read()` method returns [ramn93::R](ramn93::R) reader structure"]
impl crate::Readable for RAMN93 {}
#[doc = "`write(|w| ..)` method takes [ramn93::W](ramn93::W) writer structure"]
impl crate::Writable for RAMN93 {}
#[doc = "Embedded RAM"]
pub mod ramn93;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn94](ramn94) module"]
pub type RAMN94 = crate::Reg<u32, _RAMN94>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN94;
#[doc = "`read()` method returns [ramn94::R](ramn94::R) reader structure"]
impl crate::Readable for RAMN94 {}
#[doc = "`write(|w| ..)` method takes [ramn94::W](ramn94::W) writer structure"]
impl crate::Writable for RAMN94 {}
#[doc = "Embedded RAM"]
pub mod ramn94;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn95](ramn95) module"]
pub type RAMN95 = crate::Reg<u32, _RAMN95>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN95;
#[doc = "`read()` method returns [ramn95::R](ramn95::R) reader structure"]
impl crate::Readable for RAMN95 {}
#[doc = "`write(|w| ..)` method takes [ramn95::W](ramn95::W) writer structure"]
impl crate::Writable for RAMN95 {}
#[doc = "Embedded RAM"]
pub mod ramn95;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn96](ramn96) module"]
pub type RAMN96 = crate::Reg<u32, _RAMN96>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN96;
#[doc = "`read()` method returns [ramn96::R](ramn96::R) reader structure"]
impl crate::Readable for RAMN96 {}
#[doc = "`write(|w| ..)` method takes [ramn96::W](ramn96::W) writer structure"]
impl crate::Writable for RAMN96 {}
#[doc = "Embedded RAM"]
pub mod ramn96;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn97](ramn97) module"]
pub type RAMN97 = crate::Reg<u32, _RAMN97>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN97;
#[doc = "`read()` method returns [ramn97::R](ramn97::R) reader structure"]
impl crate::Readable for RAMN97 {}
#[doc = "`write(|w| ..)` method takes [ramn97::W](ramn97::W) writer structure"]
impl crate::Writable for RAMN97 {}
#[doc = "Embedded RAM"]
pub mod ramn97;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn98](ramn98) module"]
pub type RAMN98 = crate::Reg<u32, _RAMN98>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN98;
#[doc = "`read()` method returns [ramn98::R](ramn98::R) reader structure"]
impl crate::Readable for RAMN98 {}
#[doc = "`write(|w| ..)` method takes [ramn98::W](ramn98::W) writer structure"]
impl crate::Writable for RAMN98 {}
#[doc = "Embedded RAM"]
pub mod ramn98;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn99](ramn99) module"]
pub type RAMN99 = crate::Reg<u32, _RAMN99>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN99;
#[doc = "`read()` method returns [ramn99::R](ramn99::R) reader structure"]
impl crate::Readable for RAMN99 {}
#[doc = "`write(|w| ..)` method takes [ramn99::W](ramn99::W) writer structure"]
impl crate::Writable for RAMN99 {}
#[doc = "Embedded RAM"]
pub mod ramn99;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn100](ramn100) module"]
pub type RAMN100 = crate::Reg<u32, _RAMN100>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN100;
#[doc = "`read()` method returns [ramn100::R](ramn100::R) reader structure"]
impl crate::Readable for RAMN100 {}
#[doc = "`write(|w| ..)` method takes [ramn100::W](ramn100::W) writer structure"]
impl crate::Writable for RAMN100 {}
#[doc = "Embedded RAM"]
pub mod ramn100;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn101](ramn101) module"]
pub type RAMN101 = crate::Reg<u32, _RAMN101>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN101;
#[doc = "`read()` method returns [ramn101::R](ramn101::R) reader structure"]
impl crate::Readable for RAMN101 {}
#[doc = "`write(|w| ..)` method takes [ramn101::W](ramn101::W) writer structure"]
impl crate::Writable for RAMN101 {}
#[doc = "Embedded RAM"]
pub mod ramn101;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn102](ramn102) module"]
pub type RAMN102 = crate::Reg<u32, _RAMN102>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN102;
#[doc = "`read()` method returns [ramn102::R](ramn102::R) reader structure"]
impl crate::Readable for RAMN102 {}
#[doc = "`write(|w| ..)` method takes [ramn102::W](ramn102::W) writer structure"]
impl crate::Writable for RAMN102 {}
#[doc = "Embedded RAM"]
pub mod ramn102;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn103](ramn103) module"]
pub type RAMN103 = crate::Reg<u32, _RAMN103>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN103;
#[doc = "`read()` method returns [ramn103::R](ramn103::R) reader structure"]
impl crate::Readable for RAMN103 {}
#[doc = "`write(|w| ..)` method takes [ramn103::W](ramn103::W) writer structure"]
impl crate::Writable for RAMN103 {}
#[doc = "Embedded RAM"]
pub mod ramn103;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn104](ramn104) module"]
pub type RAMN104 = crate::Reg<u32, _RAMN104>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN104;
#[doc = "`read()` method returns [ramn104::R](ramn104::R) reader structure"]
impl crate::Readable for RAMN104 {}
#[doc = "`write(|w| ..)` method takes [ramn104::W](ramn104::W) writer structure"]
impl crate::Writable for RAMN104 {}
#[doc = "Embedded RAM"]
pub mod ramn104;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn105](ramn105) module"]
pub type RAMN105 = crate::Reg<u32, _RAMN105>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN105;
#[doc = "`read()` method returns [ramn105::R](ramn105::R) reader structure"]
impl crate::Readable for RAMN105 {}
#[doc = "`write(|w| ..)` method takes [ramn105::W](ramn105::W) writer structure"]
impl crate::Writable for RAMN105 {}
#[doc = "Embedded RAM"]
pub mod ramn105;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn106](ramn106) module"]
pub type RAMN106 = crate::Reg<u32, _RAMN106>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN106;
#[doc = "`read()` method returns [ramn106::R](ramn106::R) reader structure"]
impl crate::Readable for RAMN106 {}
#[doc = "`write(|w| ..)` method takes [ramn106::W](ramn106::W) writer structure"]
impl crate::Writable for RAMN106 {}
#[doc = "Embedded RAM"]
pub mod ramn106;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn107](ramn107) module"]
pub type RAMN107 = crate::Reg<u32, _RAMN107>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN107;
#[doc = "`read()` method returns [ramn107::R](ramn107::R) reader structure"]
impl crate::Readable for RAMN107 {}
#[doc = "`write(|w| ..)` method takes [ramn107::W](ramn107::W) writer structure"]
impl crate::Writable for RAMN107 {}
#[doc = "Embedded RAM"]
pub mod ramn107;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn108](ramn108) module"]
pub type RAMN108 = crate::Reg<u32, _RAMN108>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN108;
#[doc = "`read()` method returns [ramn108::R](ramn108::R) reader structure"]
impl crate::Readable for RAMN108 {}
#[doc = "`write(|w| ..)` method takes [ramn108::W](ramn108::W) writer structure"]
impl crate::Writable for RAMN108 {}
#[doc = "Embedded RAM"]
pub mod ramn108;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn109](ramn109) module"]
pub type RAMN109 = crate::Reg<u32, _RAMN109>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN109;
#[doc = "`read()` method returns [ramn109::R](ramn109::R) reader structure"]
impl crate::Readable for RAMN109 {}
#[doc = "`write(|w| ..)` method takes [ramn109::W](ramn109::W) writer structure"]
impl crate::Writable for RAMN109 {}
#[doc = "Embedded RAM"]
pub mod ramn109;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn110](ramn110) module"]
pub type RAMN110 = crate::Reg<u32, _RAMN110>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN110;
#[doc = "`read()` method returns [ramn110::R](ramn110::R) reader structure"]
impl crate::Readable for RAMN110 {}
#[doc = "`write(|w| ..)` method takes [ramn110::W](ramn110::W) writer structure"]
impl crate::Writable for RAMN110 {}
#[doc = "Embedded RAM"]
pub mod ramn110;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn111](ramn111) module"]
pub type RAMN111 = crate::Reg<u32, _RAMN111>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN111;
#[doc = "`read()` method returns [ramn111::R](ramn111::R) reader structure"]
impl crate::Readable for RAMN111 {}
#[doc = "`write(|w| ..)` method takes [ramn111::W](ramn111::W) writer structure"]
impl crate::Writable for RAMN111 {}
#[doc = "Embedded RAM"]
pub mod ramn111;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn112](ramn112) module"]
pub type RAMN112 = crate::Reg<u32, _RAMN112>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN112;
#[doc = "`read()` method returns [ramn112::R](ramn112::R) reader structure"]
impl crate::Readable for RAMN112 {}
#[doc = "`write(|w| ..)` method takes [ramn112::W](ramn112::W) writer structure"]
impl crate::Writable for RAMN112 {}
#[doc = "Embedded RAM"]
pub mod ramn112;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn113](ramn113) module"]
pub type RAMN113 = crate::Reg<u32, _RAMN113>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN113;
#[doc = "`read()` method returns [ramn113::R](ramn113::R) reader structure"]
impl crate::Readable for RAMN113 {}
#[doc = "`write(|w| ..)` method takes [ramn113::W](ramn113::W) writer structure"]
impl crate::Writable for RAMN113 {}
#[doc = "Embedded RAM"]
pub mod ramn113;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn114](ramn114) module"]
pub type RAMN114 = crate::Reg<u32, _RAMN114>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN114;
#[doc = "`read()` method returns [ramn114::R](ramn114::R) reader structure"]
impl crate::Readable for RAMN114 {}
#[doc = "`write(|w| ..)` method takes [ramn114::W](ramn114::W) writer structure"]
impl crate::Writable for RAMN114 {}
#[doc = "Embedded RAM"]
pub mod ramn114;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn115](ramn115) module"]
pub type RAMN115 = crate::Reg<u32, _RAMN115>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN115;
#[doc = "`read()` method returns [ramn115::R](ramn115::R) reader structure"]
impl crate::Readable for RAMN115 {}
#[doc = "`write(|w| ..)` method takes [ramn115::W](ramn115::W) writer structure"]
impl crate::Writable for RAMN115 {}
#[doc = "Embedded RAM"]
pub mod ramn115;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn116](ramn116) module"]
pub type RAMN116 = crate::Reg<u32, _RAMN116>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN116;
#[doc = "`read()` method returns [ramn116::R](ramn116::R) reader structure"]
impl crate::Readable for RAMN116 {}
#[doc = "`write(|w| ..)` method takes [ramn116::W](ramn116::W) writer structure"]
impl crate::Writable for RAMN116 {}
#[doc = "Embedded RAM"]
pub mod ramn116;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn117](ramn117) module"]
pub type RAMN117 = crate::Reg<u32, _RAMN117>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN117;
#[doc = "`read()` method returns [ramn117::R](ramn117::R) reader structure"]
impl crate::Readable for RAMN117 {}
#[doc = "`write(|w| ..)` method takes [ramn117::W](ramn117::W) writer structure"]
impl crate::Writable for RAMN117 {}
#[doc = "Embedded RAM"]
pub mod ramn117;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn118](ramn118) module"]
pub type RAMN118 = crate::Reg<u32, _RAMN118>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN118;
#[doc = "`read()` method returns [ramn118::R](ramn118::R) reader structure"]
impl crate::Readable for RAMN118 {}
#[doc = "`write(|w| ..)` method takes [ramn118::W](ramn118::W) writer structure"]
impl crate::Writable for RAMN118 {}
#[doc = "Embedded RAM"]
pub mod ramn118;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn119](ramn119) module"]
pub type RAMN119 = crate::Reg<u32, _RAMN119>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN119;
#[doc = "`read()` method returns [ramn119::R](ramn119::R) reader structure"]
impl crate::Readable for RAMN119 {}
#[doc = "`write(|w| ..)` method takes [ramn119::W](ramn119::W) writer structure"]
impl crate::Writable for RAMN119 {}
#[doc = "Embedded RAM"]
pub mod ramn119;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn120](ramn120) module"]
pub type RAMN120 = crate::Reg<u32, _RAMN120>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN120;
#[doc = "`read()` method returns [ramn120::R](ramn120::R) reader structure"]
impl crate::Readable for RAMN120 {}
#[doc = "`write(|w| ..)` method takes [ramn120::W](ramn120::W) writer structure"]
impl crate::Writable for RAMN120 {}
#[doc = "Embedded RAM"]
pub mod ramn120;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn121](ramn121) module"]
pub type RAMN121 = crate::Reg<u32, _RAMN121>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN121;
#[doc = "`read()` method returns [ramn121::R](ramn121::R) reader structure"]
impl crate::Readable for RAMN121 {}
#[doc = "`write(|w| ..)` method takes [ramn121::W](ramn121::W) writer structure"]
impl crate::Writable for RAMN121 {}
#[doc = "Embedded RAM"]
pub mod ramn121;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn122](ramn122) module"]
pub type RAMN122 = crate::Reg<u32, _RAMN122>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN122;
#[doc = "`read()` method returns [ramn122::R](ramn122::R) reader structure"]
impl crate::Readable for RAMN122 {}
#[doc = "`write(|w| ..)` method takes [ramn122::W](ramn122::W) writer structure"]
impl crate::Writable for RAMN122 {}
#[doc = "Embedded RAM"]
pub mod ramn122;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn123](ramn123) module"]
pub type RAMN123 = crate::Reg<u32, _RAMN123>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN123;
#[doc = "`read()` method returns [ramn123::R](ramn123::R) reader structure"]
impl crate::Readable for RAMN123 {}
#[doc = "`write(|w| ..)` method takes [ramn123::W](ramn123::W) writer structure"]
impl crate::Writable for RAMN123 {}
#[doc = "Embedded RAM"]
pub mod ramn123;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn124](ramn124) module"]
pub type RAMN124 = crate::Reg<u32, _RAMN124>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN124;
#[doc = "`read()` method returns [ramn124::R](ramn124::R) reader structure"]
impl crate::Readable for RAMN124 {}
#[doc = "`write(|w| ..)` method takes [ramn124::W](ramn124::W) writer structure"]
impl crate::Writable for RAMN124 {}
#[doc = "Embedded RAM"]
pub mod ramn124;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn125](ramn125) module"]
pub type RAMN125 = crate::Reg<u32, _RAMN125>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN125;
#[doc = "`read()` method returns [ramn125::R](ramn125::R) reader structure"]
impl crate::Readable for RAMN125 {}
#[doc = "`write(|w| ..)` method takes [ramn125::W](ramn125::W) writer structure"]
impl crate::Writable for RAMN125 {}
#[doc = "Embedded RAM"]
pub mod ramn125;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn126](ramn126) module"]
pub type RAMN126 = crate::Reg<u32, _RAMN126>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN126;
#[doc = "`read()` method returns [ramn126::R](ramn126::R) reader structure"]
impl crate::Readable for RAMN126 {}
#[doc = "`write(|w| ..)` method takes [ramn126::W](ramn126::W) writer structure"]
impl crate::Writable for RAMN126 {}
#[doc = "Embedded RAM"]
pub mod ramn126;
#[doc = "Embedded RAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ramn127](ramn127) module"]
pub type RAMN127 = crate::Reg<u32, _RAMN127>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAMN127;
#[doc = "`read()` method returns [ramn127::R](ramn127::R) reader structure"]
impl crate::Readable for RAMN127 {}
#[doc = "`write(|w| ..)` method takes [ramn127::W](ramn127::W) writer structure"]
impl crate::Writable for RAMN127 {}
#[doc = "Embedded RAM"]
pub mod ramn127;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr0](rximr0) module"]
pub type RXIMR0 = crate::Reg<u32, _RXIMR0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR0;
#[doc = "`read()` method returns [rximr0::R](rximr0::R) reader structure"]
impl crate::Readable for RXIMR0 {}
#[doc = "`write(|w| ..)` method takes [rximr0::W](rximr0::W) writer structure"]
impl crate::Writable for RXIMR0 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr0;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr1](rximr1) module"]
pub type RXIMR1 = crate::Reg<u32, _RXIMR1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR1;
#[doc = "`read()` method returns [rximr1::R](rximr1::R) reader structure"]
impl crate::Readable for RXIMR1 {}
#[doc = "`write(|w| ..)` method takes [rximr1::W](rximr1::W) writer structure"]
impl crate::Writable for RXIMR1 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr1;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr2](rximr2) module"]
pub type RXIMR2 = crate::Reg<u32, _RXIMR2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR2;
#[doc = "`read()` method returns [rximr2::R](rximr2::R) reader structure"]
impl crate::Readable for RXIMR2 {}
#[doc = "`write(|w| ..)` method takes [rximr2::W](rximr2::W) writer structure"]
impl crate::Writable for RXIMR2 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr2;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr3](rximr3) module"]
pub type RXIMR3 = crate::Reg<u32, _RXIMR3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR3;
#[doc = "`read()` method returns [rximr3::R](rximr3::R) reader structure"]
impl crate::Readable for RXIMR3 {}
#[doc = "`write(|w| ..)` method takes [rximr3::W](rximr3::W) writer structure"]
impl crate::Writable for RXIMR3 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr3;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr4](rximr4) module"]
pub type RXIMR4 = crate::Reg<u32, _RXIMR4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR4;
#[doc = "`read()` method returns [rximr4::R](rximr4::R) reader structure"]
impl crate::Readable for RXIMR4 {}
#[doc = "`write(|w| ..)` method takes [rximr4::W](rximr4::W) writer structure"]
impl crate::Writable for RXIMR4 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr4;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr5](rximr5) module"]
pub type RXIMR5 = crate::Reg<u32, _RXIMR5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR5;
#[doc = "`read()` method returns [rximr5::R](rximr5::R) reader structure"]
impl crate::Readable for RXIMR5 {}
#[doc = "`write(|w| ..)` method takes [rximr5::W](rximr5::W) writer structure"]
impl crate::Writable for RXIMR5 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr5;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr6](rximr6) module"]
pub type RXIMR6 = crate::Reg<u32, _RXIMR6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR6;
#[doc = "`read()` method returns [rximr6::R](rximr6::R) reader structure"]
impl crate::Readable for RXIMR6 {}
#[doc = "`write(|w| ..)` method takes [rximr6::W](rximr6::W) writer structure"]
impl crate::Writable for RXIMR6 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr6;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr7](rximr7) module"]
pub type RXIMR7 = crate::Reg<u32, _RXIMR7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR7;
#[doc = "`read()` method returns [rximr7::R](rximr7::R) reader structure"]
impl crate::Readable for RXIMR7 {}
#[doc = "`write(|w| ..)` method takes [rximr7::W](rximr7::W) writer structure"]
impl crate::Writable for RXIMR7 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr7;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr8](rximr8) module"]
pub type RXIMR8 = crate::Reg<u32, _RXIMR8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR8;
#[doc = "`read()` method returns [rximr8::R](rximr8::R) reader structure"]
impl crate::Readable for RXIMR8 {}
#[doc = "`write(|w| ..)` method takes [rximr8::W](rximr8::W) writer structure"]
impl crate::Writable for RXIMR8 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr8;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr9](rximr9) module"]
pub type RXIMR9 = crate::Reg<u32, _RXIMR9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR9;
#[doc = "`read()` method returns [rximr9::R](rximr9::R) reader structure"]
impl crate::Readable for RXIMR9 {}
#[doc = "`write(|w| ..)` method takes [rximr9::W](rximr9::W) writer structure"]
impl crate::Writable for RXIMR9 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr9;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr10](rximr10) module"]
pub type RXIMR10 = crate::Reg<u32, _RXIMR10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR10;
#[doc = "`read()` method returns [rximr10::R](rximr10::R) reader structure"]
impl crate::Readable for RXIMR10 {}
#[doc = "`write(|w| ..)` method takes [rximr10::W](rximr10::W) writer structure"]
impl crate::Writable for RXIMR10 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr10;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr11](rximr11) module"]
pub type RXIMR11 = crate::Reg<u32, _RXIMR11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR11;
#[doc = "`read()` method returns [rximr11::R](rximr11::R) reader structure"]
impl crate::Readable for RXIMR11 {}
#[doc = "`write(|w| ..)` method takes [rximr11::W](rximr11::W) writer structure"]
impl crate::Writable for RXIMR11 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr11;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr12](rximr12) module"]
pub type RXIMR12 = crate::Reg<u32, _RXIMR12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR12;
#[doc = "`read()` method returns [rximr12::R](rximr12::R) reader structure"]
impl crate::Readable for RXIMR12 {}
#[doc = "`write(|w| ..)` method takes [rximr12::W](rximr12::W) writer structure"]
impl crate::Writable for RXIMR12 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr12;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr13](rximr13) module"]
pub type RXIMR13 = crate::Reg<u32, _RXIMR13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR13;
#[doc = "`read()` method returns [rximr13::R](rximr13::R) reader structure"]
impl crate::Readable for RXIMR13 {}
#[doc = "`write(|w| ..)` method takes [rximr13::W](rximr13::W) writer structure"]
impl crate::Writable for RXIMR13 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr13;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr14](rximr14) module"]
pub type RXIMR14 = crate::Reg<u32, _RXIMR14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR14;
#[doc = "`read()` method returns [rximr14::R](rximr14::R) reader structure"]
impl crate::Readable for RXIMR14 {}
#[doc = "`write(|w| ..)` method takes [rximr14::W](rximr14::W) writer structure"]
impl crate::Writable for RXIMR14 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr14;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr15](rximr15) module"]
pub type RXIMR15 = crate::Reg<u32, _RXIMR15>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR15;
#[doc = "`read()` method returns [rximr15::R](rximr15::R) reader structure"]
impl crate::Readable for RXIMR15 {}
#[doc = "`write(|w| ..)` method takes [rximr15::W](rximr15::W) writer structure"]
impl crate::Writable for RXIMR15 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr15;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr16](rximr16) module"]
pub type RXIMR16 = crate::Reg<u32, _RXIMR16>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR16;
#[doc = "`read()` method returns [rximr16::R](rximr16::R) reader structure"]
impl crate::Readable for RXIMR16 {}
#[doc = "`write(|w| ..)` method takes [rximr16::W](rximr16::W) writer structure"]
impl crate::Writable for RXIMR16 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr16;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr17](rximr17) module"]
pub type RXIMR17 = crate::Reg<u32, _RXIMR17>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR17;
#[doc = "`read()` method returns [rximr17::R](rximr17::R) reader structure"]
impl crate::Readable for RXIMR17 {}
#[doc = "`write(|w| ..)` method takes [rximr17::W](rximr17::W) writer structure"]
impl crate::Writable for RXIMR17 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr17;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr18](rximr18) module"]
pub type RXIMR18 = crate::Reg<u32, _RXIMR18>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR18;
#[doc = "`read()` method returns [rximr18::R](rximr18::R) reader structure"]
impl crate::Readable for RXIMR18 {}
#[doc = "`write(|w| ..)` method takes [rximr18::W](rximr18::W) writer structure"]
impl crate::Writable for RXIMR18 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr18;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr19](rximr19) module"]
pub type RXIMR19 = crate::Reg<u32, _RXIMR19>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR19;
#[doc = "`read()` method returns [rximr19::R](rximr19::R) reader structure"]
impl crate::Readable for RXIMR19 {}
#[doc = "`write(|w| ..)` method takes [rximr19::W](rximr19::W) writer structure"]
impl crate::Writable for RXIMR19 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr19;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr20](rximr20) module"]
pub type RXIMR20 = crate::Reg<u32, _RXIMR20>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR20;
#[doc = "`read()` method returns [rximr20::R](rximr20::R) reader structure"]
impl crate::Readable for RXIMR20 {}
#[doc = "`write(|w| ..)` method takes [rximr20::W](rximr20::W) writer structure"]
impl crate::Writable for RXIMR20 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr20;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr21](rximr21) module"]
pub type RXIMR21 = crate::Reg<u32, _RXIMR21>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR21;
#[doc = "`read()` method returns [rximr21::R](rximr21::R) reader structure"]
impl crate::Readable for RXIMR21 {}
#[doc = "`write(|w| ..)` method takes [rximr21::W](rximr21::W) writer structure"]
impl crate::Writable for RXIMR21 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr21;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr22](rximr22) module"]
pub type RXIMR22 = crate::Reg<u32, _RXIMR22>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR22;
#[doc = "`read()` method returns [rximr22::R](rximr22::R) reader structure"]
impl crate::Readable for RXIMR22 {}
#[doc = "`write(|w| ..)` method takes [rximr22::W](rximr22::W) writer structure"]
impl crate::Writable for RXIMR22 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr22;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr23](rximr23) module"]
pub type RXIMR23 = crate::Reg<u32, _RXIMR23>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR23;
#[doc = "`read()` method returns [rximr23::R](rximr23::R) reader structure"]
impl crate::Readable for RXIMR23 {}
#[doc = "`write(|w| ..)` method takes [rximr23::W](rximr23::W) writer structure"]
impl crate::Writable for RXIMR23 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr23;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr24](rximr24) module"]
pub type RXIMR24 = crate::Reg<u32, _RXIMR24>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR24;
#[doc = "`read()` method returns [rximr24::R](rximr24::R) reader structure"]
impl crate::Readable for RXIMR24 {}
#[doc = "`write(|w| ..)` method takes [rximr24::W](rximr24::W) writer structure"]
impl crate::Writable for RXIMR24 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr24;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr25](rximr25) module"]
pub type RXIMR25 = crate::Reg<u32, _RXIMR25>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR25;
#[doc = "`read()` method returns [rximr25::R](rximr25::R) reader structure"]
impl crate::Readable for RXIMR25 {}
#[doc = "`write(|w| ..)` method takes [rximr25::W](rximr25::W) writer structure"]
impl crate::Writable for RXIMR25 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr25;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr26](rximr26) module"]
pub type RXIMR26 = crate::Reg<u32, _RXIMR26>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR26;
#[doc = "`read()` method returns [rximr26::R](rximr26::R) reader structure"]
impl crate::Readable for RXIMR26 {}
#[doc = "`write(|w| ..)` method takes [rximr26::W](rximr26::W) writer structure"]
impl crate::Writable for RXIMR26 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr26;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr27](rximr27) module"]
pub type RXIMR27 = crate::Reg<u32, _RXIMR27>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR27;
#[doc = "`read()` method returns [rximr27::R](rximr27::R) reader structure"]
impl crate::Readable for RXIMR27 {}
#[doc = "`write(|w| ..)` method takes [rximr27::W](rximr27::W) writer structure"]
impl crate::Writable for RXIMR27 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr27;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr28](rximr28) module"]
pub type RXIMR28 = crate::Reg<u32, _RXIMR28>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR28;
#[doc = "`read()` method returns [rximr28::R](rximr28::R) reader structure"]
impl crate::Readable for RXIMR28 {}
#[doc = "`write(|w| ..)` method takes [rximr28::W](rximr28::W) writer structure"]
impl crate::Writable for RXIMR28 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr28;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr29](rximr29) module"]
pub type RXIMR29 = crate::Reg<u32, _RXIMR29>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR29;
#[doc = "`read()` method returns [rximr29::R](rximr29::R) reader structure"]
impl crate::Readable for RXIMR29 {}
#[doc = "`write(|w| ..)` method takes [rximr29::W](rximr29::W) writer structure"]
impl crate::Writable for RXIMR29 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr29;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr30](rximr30) module"]
pub type RXIMR30 = crate::Reg<u32, _RXIMR30>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR30;
#[doc = "`read()` method returns [rximr30::R](rximr30::R) reader structure"]
impl crate::Readable for RXIMR30 {}
#[doc = "`write(|w| ..)` method takes [rximr30::W](rximr30::W) writer structure"]
impl crate::Writable for RXIMR30 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr30;
#[doc = "Rx Individual Mask Registers\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rximr31](rximr31) module"]
pub type RXIMR31 = crate::Reg<u32, _RXIMR31>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RXIMR31;
#[doc = "`read()` method returns [rximr31::R](rximr31::R) reader structure"]
impl crate::Readable for RXIMR31 {}
#[doc = "`write(|w| ..)` method takes [rximr31::W](rximr31::W) writer structure"]
impl crate::Writable for RXIMR31 {}
#[doc = "Rx Individual Mask Registers"]
pub mod rximr31;
#[doc = "Pretended Networking Control 1 Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctrl1_pn](ctrl1_pn) module"]
pub type CTRL1_PN = crate::Reg<u32, _CTRL1_PN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL1_PN;
#[doc = "`read()` method returns [ctrl1_pn::R](ctrl1_pn::R) reader structure"]
impl crate::Readable for CTRL1_PN {}
#[doc = "`write(|w| ..)` method takes [ctrl1_pn::W](ctrl1_pn::W) writer structure"]
impl crate::Writable for CTRL1_PN {}
#[doc = "Pretended Networking Control 1 Register"]
pub mod ctrl1_pn;
#[doc = "Pretended Networking Control 2 Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctrl2_pn](ctrl2_pn) module"]
pub type CTRL2_PN = crate::Reg<u32, _CTRL2_PN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL2_PN;
#[doc = "`read()` method returns [ctrl2_pn::R](ctrl2_pn::R) reader structure"]
impl crate::Readable for CTRL2_PN {}
#[doc = "`write(|w| ..)` method takes [ctrl2_pn::W](ctrl2_pn::W) writer structure"]
impl crate::Writable for CTRL2_PN {}
#[doc = "Pretended Networking Control 2 Register"]
pub mod ctrl2_pn;
#[doc = "Pretended Networking Wake Up Match Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wu_mtc](wu_mtc) module"]
pub type WU_MTC = crate::Reg<u32, _WU_MTC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WU_MTC;
#[doc = "`read()` method returns [wu_mtc::R](wu_mtc::R) reader structure"]
impl crate::Readable for WU_MTC {}
#[doc = "`write(|w| ..)` method takes [wu_mtc::W](wu_mtc::W) writer structure"]
impl crate::Writable for WU_MTC {}
#[doc = "Pretended Networking Wake Up Match Register"]
pub mod wu_mtc;
#[doc = "Pretended Networking ID Filter 1 Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [flt_id1](flt_id1) module"]
pub type FLT_ID1 = crate::Reg<u32, _FLT_ID1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FLT_ID1;
#[doc = "`read()` method returns [flt_id1::R](flt_id1::R) reader structure"]
impl crate::Readable for FLT_ID1 {}
#[doc = "`write(|w| ..)` method takes [flt_id1::W](flt_id1::W) writer structure"]
impl crate::Writable for FLT_ID1 {}
#[doc = "Pretended Networking ID Filter 1 Register"]
pub mod flt_id1;
#[doc = "Pretended Networking DLC Filter Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [flt_dlc](flt_dlc) module"]
pub type FLT_DLC = crate::Reg<u32, _FLT_DLC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FLT_DLC;
#[doc = "`read()` method returns [flt_dlc::R](flt_dlc::R) reader structure"]
impl crate::Readable for FLT_DLC {}
#[doc = "`write(|w| ..)` method takes [flt_dlc::W](flt_dlc::W) writer structure"]
impl crate::Writable for FLT_DLC {}
#[doc = "Pretended Networking DLC Filter Register"]
pub mod flt_dlc;
#[doc = "Pretended Networking Payload Low Filter 1 Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pl1_lo](pl1_lo) module"]
pub type PL1_LO = crate::Reg<u32, _PL1_LO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PL1_LO;
#[doc = "`read()` method returns [pl1_lo::R](pl1_lo::R) reader structure"]
impl crate::Readable for PL1_LO {}
#[doc = "`write(|w| ..)` method takes [pl1_lo::W](pl1_lo::W) writer structure"]
impl crate::Writable for PL1_LO {}
#[doc = "Pretended Networking Payload Low Filter 1 Register"]
pub mod pl1_lo;
#[doc = "Pretended Networking Payload High Filter 1 Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pl1_hi](pl1_hi) module"]
pub type PL1_HI = crate::Reg<u32, _PL1_HI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PL1_HI;
#[doc = "`read()` method returns [pl1_hi::R](pl1_hi::R) reader structure"]
impl crate::Readable for PL1_HI {}
#[doc = "`write(|w| ..)` method takes [pl1_hi::W](pl1_hi::W) writer structure"]
impl crate::Writable for PL1_HI {}
#[doc = "Pretended Networking Payload High Filter 1 Register"]
pub mod pl1_hi;
#[doc = "Pretended Networking ID Filter 2 Register / ID Mask Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [flt_id2_idmask](flt_id2_idmask) module"]
pub type FLT_ID2_IDMASK = crate::Reg<u32, _FLT_ID2_IDMASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FLT_ID2_IDMASK;
#[doc = "`read()` method returns [flt_id2_idmask::R](flt_id2_idmask::R) reader structure"]
impl crate::Readable for FLT_ID2_IDMASK {}
#[doc = "`write(|w| ..)` method takes [flt_id2_idmask::W](flt_id2_idmask::W) writer structure"]
impl crate::Writable for FLT_ID2_IDMASK {}
#[doc = "Pretended Networking ID Filter 2 Register / ID Mask Register"]
pub mod flt_id2_idmask;
#[doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pl2_plmask_lo](pl2_plmask_lo) module"]
pub type PL2_PLMASK_LO = crate::Reg<u32, _PL2_PLMASK_LO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PL2_PLMASK_LO;
#[doc = "`read()` method returns [pl2_plmask_lo::R](pl2_plmask_lo::R) reader structure"]
impl crate::Readable for PL2_PLMASK_LO {}
#[doc = "`write(|w| ..)` method takes [pl2_plmask_lo::W](pl2_plmask_lo::W) writer structure"]
impl crate::Writable for PL2_PLMASK_LO {}
#[doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register"]
pub mod pl2_plmask_lo;
#[doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pl2_plmask_hi](pl2_plmask_hi) module"]
pub type PL2_PLMASK_HI = crate::Reg<u32, _PL2_PLMASK_HI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PL2_PLMASK_HI;
#[doc = "`read()` method returns [pl2_plmask_hi::R](pl2_plmask_hi::R) reader structure"]
impl crate::Readable for PL2_PLMASK_HI {}
#[doc = "`write(|w| ..)` method takes [pl2_plmask_hi::W](pl2_plmask_hi::W) writer structure"]
impl crate::Writable for PL2_PLMASK_HI {}
#[doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register"]
pub mod pl2_plmask_hi;
#[doc = "Wake Up Message Buffer Register for C/S\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb0_cs](wmb0_cs) module"]
pub type WMB0_CS = crate::Reg<u32, _WMB0_CS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB0_CS;
#[doc = "`read()` method returns [wmb0_cs::R](wmb0_cs::R) reader structure"]
impl crate::Readable for WMB0_CS {}
#[doc = "Wake Up Message Buffer Register for C/S"]
pub mod wmb0_cs;
#[doc = "Wake Up Message Buffer Register for ID\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb0_id](wmb0_id) module"]
pub type WMB0_ID = crate::Reg<u32, _WMB0_ID>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB0_ID;
#[doc = "`read()` method returns [wmb0_id::R](wmb0_id::R) reader structure"]
impl crate::Readable for WMB0_ID {}
#[doc = "Wake Up Message Buffer Register for ID"]
pub mod wmb0_id;
#[doc = "Wake Up Message Buffer Register for Data 0-3\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb0_d03](wmb0_d03) module"]
pub type WMB0_D03 = crate::Reg<u32, _WMB0_D03>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB0_D03;
#[doc = "`read()` method returns [wmb0_d03::R](wmb0_d03::R) reader structure"]
impl crate::Readable for WMB0_D03 {}
#[doc = "Wake Up Message Buffer Register for Data 0-3"]
pub mod wmb0_d03;
#[doc = "Wake Up Message Buffer Register Data 4-7\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb0_d47](wmb0_d47) module"]
pub type WMB0_D47 = crate::Reg<u32, _WMB0_D47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB0_D47;
#[doc = "`read()` method returns [wmb0_d47::R](wmb0_d47::R) reader structure"]
impl crate::Readable for WMB0_D47 {}
#[doc = "Wake Up Message Buffer Register Data 4-7"]
pub mod wmb0_d47;
#[doc = "Wake Up Message Buffer Register for C/S\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb1_cs](wmb1_cs) module"]
pub type WMB1_CS = crate::Reg<u32, _WMB1_CS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB1_CS;
#[doc = "`read()` method returns [wmb1_cs::R](wmb1_cs::R) reader structure"]
impl crate::Readable for WMB1_CS {}
#[doc = "Wake Up Message Buffer Register for C/S"]
pub mod wmb1_cs;
#[doc = "Wake Up Message Buffer Register for ID\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb1_id](wmb1_id) module"]
pub type WMB1_ID = crate::Reg<u32, _WMB1_ID>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB1_ID;
#[doc = "`read()` method returns [wmb1_id::R](wmb1_id::R) reader structure"]
impl crate::Readable for WMB1_ID {}
#[doc = "Wake Up Message Buffer Register for ID"]
pub mod wmb1_id;
#[doc = "Wake Up Message Buffer Register for Data 0-3\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb1_d03](wmb1_d03) module"]
pub type WMB1_D03 = crate::Reg<u32, _WMB1_D03>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB1_D03;
#[doc = "`read()` method returns [wmb1_d03::R](wmb1_d03::R) reader structure"]
impl crate::Readable for WMB1_D03 {}
#[doc = "Wake Up Message Buffer Register for Data 0-3"]
pub mod wmb1_d03;
#[doc = "Wake Up Message Buffer Register Data 4-7\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb1_d47](wmb1_d47) module"]
pub type WMB1_D47 = crate::Reg<u32, _WMB1_D47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB1_D47;
#[doc = "`read()` method returns [wmb1_d47::R](wmb1_d47::R) reader structure"]
impl crate::Readable for WMB1_D47 {}
#[doc = "Wake Up Message Buffer Register Data 4-7"]
pub mod wmb1_d47;
#[doc = "Wake Up Message Buffer Register for C/S\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb2_cs](wmb2_cs) module"]
pub type WMB2_CS = crate::Reg<u32, _WMB2_CS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB2_CS;
#[doc = "`read()` method returns [wmb2_cs::R](wmb2_cs::R) reader structure"]
impl crate::Readable for WMB2_CS {}
#[doc = "Wake Up Message Buffer Register for C/S"]
pub mod wmb2_cs;
#[doc = "Wake Up Message Buffer Register for ID\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb2_id](wmb2_id) module"]
pub type WMB2_ID = crate::Reg<u32, _WMB2_ID>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB2_ID;
#[doc = "`read()` method returns [wmb2_id::R](wmb2_id::R) reader structure"]
impl crate::Readable for WMB2_ID {}
#[doc = "Wake Up Message Buffer Register for ID"]
pub mod wmb2_id;
#[doc = "Wake Up Message Buffer Register for Data 0-3\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb2_d03](wmb2_d03) module"]
pub type WMB2_D03 = crate::Reg<u32, _WMB2_D03>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB2_D03;
#[doc = "`read()` method returns [wmb2_d03::R](wmb2_d03::R) reader structure"]
impl crate::Readable for WMB2_D03 {}
#[doc = "Wake Up Message Buffer Register for Data 0-3"]
pub mod wmb2_d03;
#[doc = "Wake Up Message Buffer Register Data 4-7\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb2_d47](wmb2_d47) module"]
pub type WMB2_D47 = crate::Reg<u32, _WMB2_D47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB2_D47;
#[doc = "`read()` method returns [wmb2_d47::R](wmb2_d47::R) reader structure"]
impl crate::Readable for WMB2_D47 {}
#[doc = "Wake Up Message Buffer Register Data 4-7"]
pub mod wmb2_d47;
#[doc = "Wake Up Message Buffer Register for C/S\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb3_cs](wmb3_cs) module"]
pub type WMB3_CS = crate::Reg<u32, _WMB3_CS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB3_CS;
#[doc = "`read()` method returns [wmb3_cs::R](wmb3_cs::R) reader structure"]
impl crate::Readable for WMB3_CS {}
#[doc = "Wake Up Message Buffer Register for C/S"]
pub mod wmb3_cs;
#[doc = "Wake Up Message Buffer Register for ID\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb3_id](wmb3_id) module"]
pub type WMB3_ID = crate::Reg<u32, _WMB3_ID>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB3_ID;
#[doc = "`read()` method returns [wmb3_id::R](wmb3_id::R) reader structure"]
impl crate::Readable for WMB3_ID {}
#[doc = "Wake Up Message Buffer Register for ID"]
pub mod wmb3_id;
#[doc = "Wake Up Message Buffer Register for Data 0-3\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb3_d03](wmb3_d03) module"]
pub type WMB3_D03 = crate::Reg<u32, _WMB3_D03>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB3_D03;
#[doc = "`read()` method returns [wmb3_d03::R](wmb3_d03::R) reader structure"]
impl crate::Readable for WMB3_D03 {}
#[doc = "Wake Up Message Buffer Register for Data 0-3"]
pub mod wmb3_d03;
#[doc = "Wake Up Message Buffer Register Data 4-7\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wmb3_d47](wmb3_d47) module"]
pub type WMB3_D47 = crate::Reg<u32, _WMB3_D47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WMB3_D47;
#[doc = "`read()` method returns [wmb3_d47::R](wmb3_d47::R) reader structure"]
impl crate::Readable for WMB3_D47 {}
#[doc = "Wake Up Message Buffer Register Data 4-7"]
pub mod wmb3_d47;
#[doc = "CAN FD Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [fdctrl](fdctrl) module"]
pub type FDCTRL = crate::Reg<u32, _FDCTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FDCTRL;
#[doc = "`read()` method returns [fdctrl::R](fdctrl::R) reader structure"]
impl crate::Readable for FDCTRL {}
#[doc = "`write(|w| ..)` method takes [fdctrl::W](fdctrl::W) writer structure"]
impl crate::Writable for FDCTRL {}
#[doc = "CAN FD Control Register"]
pub mod fdctrl;
#[doc = "CAN FD Bit Timing Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [fdcbt](fdcbt) module"]
pub type FDCBT = crate::Reg<u32, _FDCBT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FDCBT;
#[doc = "`read()` method returns [fdcbt::R](fdcbt::R) reader structure"]
impl crate::Readable for FDCBT {}
#[doc = "`write(|w| ..)` method takes [fdcbt::W](fdcbt::W) writer structure"]
impl crate::Writable for FDCBT {}
#[doc = "CAN FD Bit Timing Register"]
pub mod fdcbt;
#[doc = "CAN FD CRC Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [fdcrc](fdcrc) module"]
pub type FDCRC = crate::Reg<u32, _FDCRC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FDCRC;
#[doc = "`read()` method returns [fdcrc::R](fdcrc::R) reader structure"]
impl crate::Readable for FDCRC {}
#[doc = "CAN FD CRC Register"]
pub mod fdcrc;
